/*
 * Copyright (C) 1985-1992  New York University
 * 
 * This file is part of the Ada/Ed-C system.  See the Ada/Ed README file for
 * warranty (none) and distribution info and also the GNU General Public
 * License for more details.

 */

#pragma internal on
void ast_clear(Node);
Const const_new(int);
Const int_const(int);
Const fixed_const(long);
Const uint_const(int *);
Const real_const(double);
Const rat_const(Rational);
Boolean const_eq(Const, Const);
Boolean const_ne(Const, Const);
Boolean const_lt(Const, Const);
Boolean const_le(Const, Const);
Boolean const_gt(Const, Const);
Boolean const_ge(Const, Const);
Boolean const_same_kind(Const, Const);
Boolean const_cmp_undef(Const, Const);
Node node_new_noseq(unsigned short);
Node node_new(unsigned short);
int fx_mantissa(Rational, Rational, Rational);
void to_errfile(char *);
Boolean needs_body(Symbol);
const char *kind_str(unsigned short);
const char *nature_str(short);
Boolean in_open_scopes(Symbol);
char *newat_str(char *);
char *str_newat(char *);
void symtab_copy(Symbol, Symbol);
void sym_copy(Symbol, Symbol);
void SYMBTABcopy(Symbol, Symbol);
Symbol sym_new_noseq(short);
Symbol sym_new(short);
Private_declarations private_decls_new(int);
Symbol private_decls_get(Private_declarations, Symbol);
void private_decls_put(Private_declarations, Symbol);
void private_decls_swap(Symbol, Symbol);
const char *attribute_str(short);
int no_dimensions(Symbol);
Boolean in_incp_types(Symbol);
Boolean in_qualifiers(unsigned short);
Boolean in_univ_types(Symbol);
Boolean in_vis_mods(Symbol);
void undone(char *);
Boolean is_type(Symbol);
Boolean is_fixed_type(Symbol);
short is_generic_type(Symbol);
Boolean is_access(Symbol);
Boolean is_scalar_type(Symbol);
Boolean is_numeric_type(Symbol);
Boolean is_record(Symbol);
Boolean is_anonymous_task(Symbol);
Boolean is_task_type(Symbol);
Node discr_map_get(Tuple, Symbol);
Tuple discr_map_put(Tuple, Symbol, Node);
Boolean tup_memsym(Symbol, Tuple);
void const_check(Const, int);
int power_of_2(Const);
Node new_ivalue_node(Const, Symbol);
Tuple constraint_new(int);

extern int N_DEFINED[];
#pragma internal reset

