#include "crtlocal.h"
#include "proc_mmu.h"

 	extract(tc, 0x0003);
 	extract(itt0, 0x0004);
 	extract(itt1, 0x0005);
 	extract(dtt0, 0x0006);
 	extract(dtt1, 0x0007);
 	extract(caar, 0x0802);
// 	extract(msp, 0x0803);
 	extract(isp, 0x0804);
 	extract(mmusr, 0x0805);
 	extract(urp, 0x0806);
 	extract(srp, 0x0807);

#pragma parameter put_dtt0(__D0)
	stuff(put_dtt0, 0x0006);
#pragma parameter put_urp(__D0)
	stuff(put_urp, 0x0806);
	
#pragma parameter __A0 ptestw(__A0)
static long ptestw(long) = {0xF548};

static void pflusha(void) = {0xF518};
static void pflushan(void) = {0xF510};
static void cpusha(void) = {0xF4F8};

long get_68040_tc()
	{
	return tc();
	}

void get_68040_crp(long *vec)
	{
	vec[0] = 127;
	vec[1] = urp();
	}

void get_68040_srp(long *vec)
	{
	vec[0] = 127;
	vec[1] = srp();
	}
	
void put_68040_crp(long *vec)
	{
	put_urp(vec[1]);
	}

void flush_68040_caches(void)
	{
	cpusha();	
	}

void flush_68040_mmu_caches(void)
	{
	pflusha();
	pflushan();
	}

#define MMU68040
pascal void trap_patch_68040_0(void)
#include "patch0.c"

pascal void trap_patch_68040_1(unsigned short fault)
#include "patch1.c"
