#include <sys/types.h>
#include <sys/syslimits.h>
#include <fcntl.h>
#include <errno.h>
#include "crtlocal.h"

int mkdir(const char *name, int flags)
	{
	long createdDirID;
	int i;
	OSErr err;
    HParamBlockRec pb;
    FSSpec name1 = hfs_canon(crt_parID, name, 1);
    if (!*name1.name) return -1;
	err = FSpDirCreate(&name1,0,&createdDirID);
	if (err) errno = errtran(err);
	return err?-1:0;
	}

int rmdir(const char *name)
	{
	long filenum;
	int i;
	OSErr err;
    HParamBlockRec pb;
    FSSpec name1 = hfs_canon(crt_parID, name, 0);
    if (!*name1.name) return -1;
    pb.fileParam.ioNamePtr = name1.name;
    pb.fileParam.ioVRefNum = name1.vRefNum;
    pb.fileParam.ioDirID = name1.parID;
	err = PBHDeleteSync(&pb);
	if (err) errno = errtran(err);
	return err?-1:0;
	}
