/*
********************************************************************************
**
** File: main.h
**
** Description:
**
**	Header file for Rumor Mill application.
**
********************************************************************************
**
** Revision History:
**
** 12/06/97 Farrier	Created.
**
********************************************************************************
*/
#pragma once

#include <LApplication.h>
#include <LListener.h>
#include <UKeyFilters.h>

class	CRumorMillApp : public LApplication, public LListener
{
	LEditField	*mIncomingRumor;
	
public:
						CRumorMillApp();		// constructor registers all PPobs
	virtual 			~CRumorMillApp();		// stub destructor
	
		// this overriding function performs application functions
		
	virtual Boolean		ObeyCommand(CommandT inCommand, void* ioParam);	
	
		// this overriding function returns the status of menu items
		
	virtual void		FindCommandStatus(CommandT inCommand,
							Boolean &outEnabled, Boolean &outUsesMark,
							Char16 &outMark, Str255 outName);
	
	virtual void	ListenToMessage(MessageT inMessage, void *ioParam);
	
	Boolean NetStart( void );
	Boolean RegisterName( UInt8 inSocket );
	Boolean UnregisterName( void );
	Boolean NetStop( void );
	Boolean SendRumor( Str255 inRumorText );
	Boolean DisplayRumor( void );
	Boolean FindOtherMills( void );

	virtual void		ProcessNextEvent();
	void	SetStatusMessage( Str255 inStatus );
	void	GetStatusMessage( Str255 inStatus );
	
	static EKeyStatus KeyFilterFunction( const EventRecord&	inKeyEvent );
	
protected:

	virtual void		StartUp();		// overriding startup functions
};