#
#	File:		unshar.make
#
#	Contains:	Makefile to build unshar tool
#
#	Written by:	Sak Wathanasin
#				178 Wainbody Ave South
#				Coventry CV3 6BX
#				UK
#	Phone:		+44 203 419996
#	E-mail:		sw@network-analysis-ltd.co.uk
#
#	Copyright:	Public Domain
#
#	Change History (most recent first):
#
#	<5+>		12/10/95	sw		Default compilers now SC/SCpp
#	<5>			29/07/95	sw		Remove need for CWMPWGlue
#	<4>			21/07/95	sw		Add cmds for MW compiler/linker
#	<3>			30/06/95	sw		Build PPC-native tool
#	<2>			  3/2/91	sw		Change link libs for MPW 3.2
#	<1>			  6/7/90  	sw		Created base version
#
#	To Do:
#
VERSION	= 1.11
OBJECTS = unshar.c.o

C			=	MWC68K
Link		=	MWLink68K
SymOptions	=	-sym off
SymOpt		=	{SymOptions}
COptions	=	-r {SymOpt} -mbg full  -d MPW -AppleExt On

# The following is for Metrowerks
PPCC		= MWCPPC
PPCLink		= MWLinkPPC
PPCCOptions	=	-AppleExt On {SymOpt} -opt l4 -d MPW -d REG=register -i "{CIncludes}"
StdLibs =	
			"{MWPPCLibraries}"MWStdCRuntime.Lib 
			"{MWPPCLibraries}"InterfaceLib   
			"{MWPPCLibraries}"StdCLib 
			"{MWPPCLibraries}MathLib" 
			"{MWPPCLibraries}"PPCToolLibs.o

# The following is for MrC
# PPCCOptions=	-AppleExt On {SymOpt} -opt speed -d MPW -d REG=register
# PPPC		= PPCC
# PPCLink	= PPCLink
# StdLibs	=	"{PPCLibraries}"StdCRuntime.o 
#   			"{PPCLibraries}"StdCLib.xcoff 
#  			"{PPCLibraries}"InterfaceLib.xcoff 
# 			"{PPCLibraries}"Mathlib.xcoff 
# 			"{PPCLibraries}"PPCCRuntime.o 
# 			"{PPCLibraries}"PPCToolLibs.o

.c.x		.c
	{PPCC} {Default}.c -o {Default}.c.x {PPCCOptions}

# The following only needed for MrC builds
# The "evaluate" stuff in the MakePEF command is simply a way
# of specifying version 1.1a3 of the StdCLib library.  (The
# version number format is the same as a 'vers' resource.) The
# library version number must be specified to ensure that the native
# version of the tool does not use the broken StdCLib in ROM.
# 
# unshar			unshar.xcoff
#  	MakePEF unshar.xcoff -o unshar -ft MPST -fc 'MPS ' 
#  		-l InterfaceLib.xcoff=InterfaceLib 
#  		-l "StdCLib.xcoff=StdCLib#`evaluate 0x01104003`"
#  	if "{SymOpt}" =~ /-sym [NnUu]+/
#  		MakeSym -w unshar.xcoff -o unshar.xSYM
#  	End
# 
# unshar.xcoff			unshar.c.x
unshar					unshar.c.x
	{PPCLink} {SymOpt} -d unshar.c.x 
		{StdLibs} 
		-o {Targ}

# The 68K part
#	The following used for MPW C
#		"{Libraries}"Stubs.o 
#		"{Libraries}"Runtime.o 
#		"{Libraries}"Interface.o 
#		"{CLibraries}"StdClib.o 
#		"{Libraries}"ToolLibs.o 
unshar  unshar.make {OBJECTS}
	{Link} -d -c 'MPS ' -t MPST {SymOpt} -mf 
		-xm mpwtool 
		{OBJECTS} 
		"{MW68KLibraries}MPW ANSI (4i/8d) C.68K.Lib" 
		"{MW68KLibraries}MacOS.lib" 
		"{MW68KLibraries}MathLib68K (4i/8d).lib" 
		"{MW68KLibraries}ToolLibs.o" 
		-o unshar

unshar		GenericCFRG.r
	Rez {NewerDeps} -o unshar -append -d APPNAME="unshar" 

unshar		unshar.c unshar.make
	SetVersion -t 'vers' -i 1 -version "{VERSION}" unshar
	SetFile -m . -c 'MPS ' -t MPST unshar
