// MyProject.h

// include files
#include <Controls.h>
#include <Windows.h>
#include <Dialogs.h>

// macros and defines
#define		TRUE			1
#define		FALSE			0

#define		MAIN_WINDOW		100
#define		ERROR_WINDOW	200

// stuff for MenuBar.c
#define		MENU_APPLE		128
#define		MENU_FILE		129
#define		MENU_EDIT		130
#define		APPLE_ABOUT		1
#define		FILE_QUIT		1
#define		EDIT_UNDO		1
#define		EDIT_CUT		3
#define		EDIT_COPY		4
#define		EDIT_PASTE		5
#define		EDIT_CLEAR		6
#define		EDIT_SELECTALL	8

// stuff for MyColors.c
#define		WHITE_COLOR		0xFFFF
#define		BLACK_COLOR		0x0000
#define		GREY_A			0xED12
#define		GREY_B			0xC23D
#define		GREY_C			0xBA45
#define		GREY_D			0xA956
#define		GREY_E			0x8778
#define		GREY_F			0x7689
#define		GREY_G			0x54AB
#define		GREY_H			0x43BC
#define		GREY_I			0x21DE
#define		GREY_J			0x10EF
#define		extrudeIn		0
#define		extrudeOut		1

// structs
// this struct is used to hold info about my window.
typedef struct {
	// the window pointer
	WindowPtr		window;
	WindowPtr		error;
	
	// Control handles
	ControlHandle	hControl;
	ControlHandle	hAppleControl;
	
	// icon info
	CIconHandle		icon;
	
	// data
	Str255			errMsg;
} Main, *MainPtr, **MainHan;

// this struct is used to force parm into this format for FillCntlParameters().
typedef struct {
	Rect	limitRect;
	Rect	slopRect;
	short	axis;
} CntlParm, *CntlParmPtr;	

// This is our information we store in the contrlData field.
typedef struct {
	// all of the parts
	Rect		cntlRect;
	Rect		thumbRect;
	Rect		arrowLT;		// Left or Top arrow depending if we are horz or vert
	Rect		arrowRB;		// Right or Bottom arrow depending if we are horz or vert
	Rect		trackRect;
} MyCntlData, *MyCntlDataPtr, **MyCntlDataHan;	

// these are parameters used to set up you control. Used by SetUpMyControl()
typedef struct {
	WindowPtr		theWindow;
	Rect			cntlRect;
	Str255			title;
	Boolean			visible;
	short			initialValue;
	short			min;
	short			max;
	short			cntlType;
} CntlParam;
