// -----------------------------------------------------------------------------
//	File	: comparePopup.r
//	Date	: October 30, 1994
//	Author	: Jim Stout
//	Purpose	: resource descriptions for the comparePopup dialog, a simple 
//			: side by side comparison of System 7 CDEF 63 and CDEF 1101.
//
// -----------------------------------------------------------------------------
#define SystemSevenOrLater 1
#include <Types.r>
#include <SysTypes.r>
#include "jimsCDEF.h"		// variation codes for the CDEFs

#define useCQD 2			// the Sys6 (now obsolete ?) CDEF 63 variation

resource 'dctb' (259, purgeable) {
	{
		/* [1] */		wContentColor, 52428,52428,52428,		// gray
		/* [2] */		wFrameColor, 0, 0, 0,
		/* [3] */		wTextColor, 0, 0, 0,
		/* [4] */		wHiliteColor, 0, 0, 0,
		/* [5] */		wTitleBarColor, 65535, 65535, 65535
	}
};

resource 'DLOG' (259, "Compare popup", purgeable) {
	{46, 15, 340, 493},	movableDBoxProc,	invisible,	nogoAway,	0x0,	259,
	"Compare Popup CDEFs",
#if SystemSevenOrLater
	centerMainScreen
#endif
};

resource 'DITL' (259, "Compare popup", purgeable) {
	{
		/* [1] */	{261, 406, 281, 465},	Button		{enabled, "OK"		},
		/* [2] */	{261, 334, 281, 393},	Button 		{enabled, "Cancel"	},
		/* [3] */	{261, 40, 281, 99},		Button		{enabled, "Disable"	},
		
		/* [4] */	{10, 10, 33, 240},		Control 	{enabled,	2590	},
		/* [5] */	{43, 10, 66, 240},		Control 	{enabled,	2591	},
		
		/* [6] */	{81, 10, 102, 240},		Control 	{enabled,	2592	},
		/* [7] */	{112, 10, 135, 240},	Control 	{enabled,	2593	},
		
		/* [8] */	{10, 250, 33, 470},		Control 	{enabled,	2594	},
		/* [9] */	{43, 250, 66, 470},		Control 	{enabled,	2595	},
		
		/* [10] */	{81, 250, 102, 470},	Control 	{enabled,	2596	},
		/* [11] */	{112, 250, 135, 470},	Control 	{enabled,	2597	},
		
		/* [12] */	{140, 10, 194, 280},	Control 	{enabled,	2598	},
		/* [13] */	{199, 10, 253, 280},	Control 	{enabled,	2599	},
		
		/* [14] */	{157, 320, 173, 470},	Control 	{enabled,	2600	},
		/* [15] */	{178, 320, 194, 470},	Control 	{enabled,	2601	},
	}
};
//
// the following 'CNTL' definitions are pairs using identical parameters
// to show the similarity between the System 7 CDEF 63 and the CDEF 101
// in Jim's CDEFs.
//
resource 'CNTL' (2590, purgeable) {
	{10, 10, 33, 240}, 
	popupTitleRightJust,			
	visible,	
	80,		
	2590,	
	16*popUp+popupFixedWidth,
	0,	
	"CDEF 101:"
};
resource 'CNTL' (2591, purgeable) {
	{43, 10, 66, 240}, 
	popupTitleRightJust,			
	visible,	
	80,		
	2591,	
	16*63+popupFixedWidth+useCQD,
	0,	
	"CDEF 63:"
};

resource 'CNTL' (2592, purgeable) {
	{81, 10, 102, 240},	
	popupTitleLeftJust,			
	visible,	
	80,		
	2592,	
	16*popUp+popupFixedWidth,		
	0,	
	"CDEF 101:"
};
resource 'CNTL' (2593, purgeable) {
	{112, 10, 135, 240},	
	popupTitleLeftJust,			
	visible,	
	80,		
	2593,	
	16*63+useCQD+popupFixedWidth,		
	0,	
	"CDEF 63:"
};

resource 'CNTL' (2594, purgeable) {
	{10, 250, 33, 470},	
	popupTitleCenterJust+popupTitleOutline,	
	visible,	
	80,		
	2594,	
	16*popUp+popupFixedWidth,		
	0,	
	"CDEF 101:"
};
resource 'CNTL' (2595, purgeable) {
	{43, 250, 66, 470},	
	popupTitleCenterJust+popupTitleOutline,	
	visible,	
	80,		
	2595,	
	16*63+useCQD+popupFixedWidth,		
	0,	
	"CDEF 63:"
};

resource 'CNTL' (2596, purgeable) {
	{81, 250, 102, 470},	
	popupTitleRightJust+popupTitleItalic,	
	visible,	
	80,		
	2596,	
	16*popUp,		
	0,	
	"CDEF 101: "
};
resource 'CNTL' (2597, purgeable) {
	{112, 250, 135, 470},	
	popupTitleRightJust+popupTitleItalic,	
	visible,	
	80,		
	2597,	
	16*63+useCQD,		
	0,	
	"CDEF 63: "
};

resource 'CNTL' (2598, purgeable) {
	{140, 10, 194, 280},	
	popupTitleRightJust,	
	visible,	
	80,		
	2598,	
	16*popUp,		
	0,	
	"CDEF 101:"
};
resource 'CNTL' (2599, purgeable) {
	{199, 10, 253, 280},	
	popupTitleRightJust,	
	visible,	
	80,		
	2599,	
	16*63+useCQD,		
	0,	
	"CDEF 63:"
};

resource 'CNTL' (2600, purgeable) {
	{157, 320, 173, 470},	
	popupTitleRightJust,	
	visible,	
	60,		
	2600,	
	16*popUp+useWFont+popupFixedWidth,		
	0,	
	"CDEF 101:"
};
resource 'CNTL' (2601, purgeable) {
	{178, 320, 194, 470},	
	popupTitleRightJust,	
	visible,	
	60,		
	2601,	
	16*63+useCQD+useWFont+popupFixedWidth,		
	0,	
	"CDEF 63:"
};

resource 'MENU' (2590) {
	2590, textMenuProc,	allEnabled,	enabled,	"compare menu 1",
	{
		/* [1] */	"Styled Item Text", 		noIcon, noKey, noMark, plain,
		/* [2] */	"Red Italic", 				noIcon, noKey, noMark, italic,
		/* [3] */	"Blue Outline", 			noIcon, noKey, noMark, outline,
		/* [4] */	"Green Bold", 				noIcon, noKey, noMark, bold,
		/* [5] */	"Item Five is a long item", noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2591) {
	2591, textMenuProc,	allEnabled,	enabled,	"compare menu 1",
	{
		/* [1] */	"Styled Item Text", 		noIcon, noKey, noMark, plain,
		/* [2] */	"Red Italic", 				noIcon, noKey, noMark, italic,
		/* [3] */	"Blue Outline", 			noIcon, noKey, noMark, outline,
		/* [4] */	"Green Bold", 				noIcon, noKey, noMark, bold,
		/* [5] */	"Item Five is a long item", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (2592) {
	2592, textMenuProc,	0x7ffffffe,	enabled,	"compare menu 2",
	{
		/* [1] */	"Disabled Item", 			noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleLeftJust",		 	noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2593) {
	2593, textMenuProc,	0x7ffffffe,	enabled,	"compare menu 2",
	{
		/* [1] */	"Disabled Item", 			noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleLeftJust",		 	noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2594) {
	2594, textMenuProc,	allEnabled,	enabled,	"compare menu 3",
	{
		/* [1] */	"Colored Item Text",		noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleCenterJust",		 	noIcon, noKey, noMark, plain,
		/* [4] */	"TitleOutline",		 		noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2595) {
	2595, textMenuProc,	allEnabled,	enabled,	"compare menu 3",
	{
		/* [1] */	"Colored Item Text",		noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleCenterJust",		 	noIcon, noKey, noMark, plain,
		/* [4] */	"TitleOutline",		 		noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2596) {
	2596, textMenuProc,	allEnabled,	enabled,	"compare menu 4",
	{
		/* [1] */	"PopUp CDEF",	 			noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleRightJust",		 	noIcon, noKey, noMark, plain,
		/* [4] */	"TitleItalic",		 		noIcon, noKey, noMark, plain,
		/* [5] */	"and without",		 		noIcon, noKey, noMark, plain,
		/* [6] */	"FixedWidth",		 		noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2597) {
	2597, textMenuProc,	allEnabled,	enabled,	"compare menu 4",
	{
		/* [1] */	"PopUp CDEF",	 			noIcon, noKey, noMark, plain,
		/* [2] */	"with",		 				noIcon, noKey, noMark, plain,
		/* [3] */	"TitleRightJust",		 	noIcon, noKey, noMark, plain,
		/* [4] */	"TitleItalic",		 		noIcon, noKey, noMark, plain,
		/* [5] */	"and without",		 		noIcon, noKey, noMark, plain,
		/* [6] */	"FixedWidth",		 		noIcon, noKey, noMark, plain
	}
};
resource 'MENU' (2598) {
	2598, textMenuProc,	allEnabled,	enabled,	"compare menu 5",
	{
		/* [1] */	"Small cicn", 				44, noKey, noMark, plain,
		/* [2] */	"Large cicn",		 		45, noKey, noMark, plain,
		/* [3] */	"Very Large cicn",			46,	noKey, noMark, plain,
		/* [4] */	"B&W Icon",					5,	noKey, noMark, plain,
		/* [5] */	"B&W Icon (reduced)",		5,	"\0x1D", noMark, plain,
		/* [6] */	"Small Icon (SICN)",		6,	"\0x1E", noMark, plain,
		/* [7] */	"cicn (reduced)",			47,	"\0x1D", noMark, plain,
	}
};
resource 'MENU' (2599) {
	2599, textMenuProc,	allEnabled,	enabled,	"compare menu 5",
	{
		/* [1] */	"Small cicn", 				44, noKey, noMark, plain,
		/* [2] */	"Large cicn",		 		45, noKey, noMark, plain,
		/* [3] */	"Very Large cicn",			46,	noKey, noMark, plain,
		/* [4] */	"B&W Icon",					5,	noKey, noMark, plain,
		/* [5] */	"B&W Icon (reduced)",		5,	"\0x1D", noMark, plain,
		/* [6] */	"Small Icon (SICN)",		6,	"\0x1E", noMark, plain,
		/* [7] */	"cicn (reduced)",			47,	"\0x1D", noMark, plain,
	}
};

resource 'MENU' (2600) {
	2600, textMenuProc,	allEnabled,	enabled,	"compare menu 6",
	{
		/* [1] */	"Using the", 		noIcon, noKey, noMark, plain,
		/* [2] */	"Window",		 	noIcon, noKey, noMark, plain,
		/* [2] */	"font",		 		noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (2601) {
	2601, textMenuProc,	allEnabled,	enabled,	"compare menu 6",
	{
		/* [1] */	"Using the", 		noIcon, noKey, noMark, plain,
		/* [2] */	"Window",		 	noIcon, noKey, noMark, plain,
		/* [2] */	"font",		 		noIcon, noKey, noMark, plain
	}
};


resource 'mctb' (2590) {
	{
		/* [1] */		2590, 0,					// menu bg is turqoise
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	37715, 65535, 65535
		},
		/* [2] */		2590, 1,					// item 1 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	39321, 0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [3] */		2590, 2,					// item 2 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535,0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [4] */		2590, 3,					// item 3 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [5] */		2590, 4,					// item 4 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 8738, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		}
	}
};

resource 'mctb' (2591) {							// for CDEF 63, so this 
	{												// won't work
		/* [1] */		2591, 0,						// menu bg is turqoise
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	37715, 65535, 65535
		},
		/* [2] */		2591, 1,					// item 1 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	39321, 0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [3] */		2591, 2,					// item 2 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535,0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [4] */		2591, 3,					// item 3 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [5] */		2591, 4,					// item 4 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 8738, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		}
	}
};

resource 'mctb' (2594) {
	{
		/* [1] */		2594, 0,					// menu bg is gray
		{
			/* [1] */		0, 0, 0,
			/* [2] */		0, 0, 0,
			/* [3] */		0, 0, 0,
			/* [4] */		56797, 56797, 56797
		},
		/* [2] */		2594, 1,					// item 1 colors
		{
			/* [1] */		0, 0, 0,
			/* [2] */		13107, 0, 39321,
			/* [3] */		0, 0, 0,
			/* [4] */		65535, 65535, 65535
		},
		/* [3] */		2594, 2,					// item 2 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535,0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [4] */		2594, 3,					// item 3 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [5] */		2594, 4,					// item 4 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		}
	}
};

resource 'mctb' (2595) {
	{
		/* [1] */		2595, 0,					// menu bg is gray
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	56797, 56797, 56797
		},
		/* [2] */		2595, 1,					// item 1 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	13107, 0, 39321,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [3] */		2595, 2,					// item 2 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535,0, 0,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [4] */		2595, 3,					// item 3 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	0, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		},
		/* [5] */		2595, 4,					// item 4 colors
		{
			/* [1] */	0, 0, 0,
			/* [2] */	65535, 0, 65535,
			/* [3] */	0, 0, 0,
			/* [4] */	65535, 65535, 65535
		}
	}
};
