// -----------------------------------------------------------------------------
//	File	: demoButtons.r
//	Date	: June 18, 1995
//	Author	: Jim Stout
//	Purpose	: show use of 'cctb' resource to colorize push buttons
//			:
// -----------------------------------------------------------------------------
#define REZ									// Think 6 - see jimsCDEF.h
#define SystemSevenOrLater 1
#include <Types.r> 
#include "jimscdef.h"

resource 'dctb' (220, "Color 3D Buttons", purgeable) {
	{
		/* [1] */	wContentColor, 61166, 61166, 61166,
		/* [2] */	wFrameColor, 0, 0, 0,
		/* [3] */	wTextColor, 0, 0, 0
	}
};

resource 'DLOG' (220, "Color 3D Buttons", purgeable) {
	{44, 10, 255, 200},	movableDBoxProc,	invisible,	nogoAway,	
	0x0,	
	220,	
	"Color 3D Buttons"
#if SystemSevenOrLater
	, centerMainScreen
#endif
};

resource 'DITL' (220, "Color 3D Buttons", purgeable) {
	{
		/* [1] */	{178, 117, 198, 177},	Control		{ enabled,	221		},
		/* [2] */	{10, 1300, 30, 1360}, 	Button	{ enabled, "\Hidden"},	// offscreen
		/* [3] */	{178, 44, 198, 104},	Control		{ enabled,	222		},
		
		/* [4] */	{10, 10, 30, 70},		Control		{ enabled,	223		},
		/* [5] */	{40, 10, 60, 70},		Control		{ enabled,	224		},
		/* [6] */	{70, 10, 90, 70},		Control		{ enabled,	225		},
		/* [7] */	{10, 120, 30, 180},		Control		{ enabled,	226		},
		/* [8] */	{40, 120, 60, 180},		Control		{ enabled,	227		},
		/* [9] */	{70, 120, 90, 180},		Control		{ enabled,	228		},
		
		/* [10] */	{100, 10, 116, 180},	Control		{ enabled,	229		},
		/* [11] */	{126, 10, 142, 180},	Control		{ enabled,	230		},
		/* [12] */	{152, 10, 168, 180},	Control		{ enabled,	231		},

	}
};

resource 'CNTL' (221, purgeable) {
	{178, 117, 198, 177},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"OK"
};

resource 'CNTL' (222, purgeable) {
	{178, 44, 198, 104},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Disable"
};

resource 'CNTL' (223, purgeable) {
	{10, 10, 30, 70},	0,
	visible,	1,		0,	
	16*button3D+useWFont,
	0,
	"Blue"
};

resource 'CNTL' (224, purgeable) {
	{40, 10, 60, 70},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Red"
};

resource 'CNTL' (225, purgeable) {
	{70, 10, 90, 70},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Green"
};

resource 'CNTL' (226, purgeable) {
	{10, 120, 30, 180},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Purple"
};

resource 'CNTL' (227, purgeable) {
	{40, 120, 60, 180},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Orange"
};

resource 'CNTL' (228, purgeable) {
	{70, 120, 90, 180},	0,
	visible,	1,		0,	
	16*button3D,
	0,
	"Gray"
};

resource 'CNTL' (229, purgeable) {
	{100, 10, 116, 180},	1,
	visible,	1,		0,	
	16*button3D+2, // radioButProc,
	0,
	"Radio Button 1"
};

resource 'CNTL' (230, purgeable) {
	{126, 10, 142, 180},	0,
	visible,	1,		0,	
	16*button3D+2, // radioButProc,
	0,
	"Radio Button 2"
};

resource 'CNTL' (231, purgeable) {
	{152, 10, 168, 180},	0,
	visible,	1,		0,	
	16*button3D+1, // checkBoxProc,
	0,
	"Show pushed buttons"
};


resource 'cctb' (223, purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 52428,
		/* [2] */	cTextColor, 0, 0, 52428,
		/* [3] */	cBodyColor, 52428,-1,-1
	}
};

resource 'cctb' (224, purgeable) {
	{
		/* [1] */	cFrameColor, 61166, 0, 0,
		/* [2] */	cTextColor, 61166, 0, 0,
		/* [3] */	cBodyColor, -1,52428, 52428
	}
};

resource 'cctb' (225, purgeable) {
	{
		/* [1] */	cFrameColor, 0, 26214, 0,
		/* [2] */	cTextColor, 0, 26214, 0,
		/* [3] */	cBodyColor, 52428, -1, 52428
	}
};

resource 'cctb' (226, purgeable) {
	{
		/* [1] */	cFrameColor, 26214, 0, 26214,
		/* [2] */	cTextColor, 26214, 0, 26214,
		/* [3] */	cBodyColor, 52428, 52428, -1
	}
};

resource 'cctb' (227, purgeable) {
	{
		/* [1] */	cFrameColor, -1, 13107, 0,
		/* [2] */	cTextColor, -1, 13107, 0,
		/* [3] */	cBodyColor, -1, 52428, 39321
	}
};

resource 'cctb' (228, purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 0,
		/* [2] */	cTextColor, 0, 0, 0,
		/* [3] */	cBodyColor, 56797, 56797, 56797
	}
};