//----------------------------------------------------------------------------------
// File		: test3D.r
// Date		: July 23, 1994
// Author	: Jim Stout
//			:
// Purpose	: rez source for test3D.c
//----------------------------------------------------------------------------------
#define systemSevenOrLater 1

#include <Types.r> 
include "debug.rsrc";			// contains the dummy CDEF 128

#define CDEF0 0
#define CDEF 128				// used in CNTL templates below
#define useWFont 8				// use window font
#define useWBG 4				// use window background color
#define WANTGRAY 1

// this resource will be set by test3D.c and used by the dummy CDEF

data 'CJMP' (128, "CDEFmain address") {
	$"0000 0000"
};

// this resource will color dialog id=128 - and is needed to allow the 'cctb's to work

resource 'dctb' (128) {
	{	/* array ColorSpec: 5 elements */
#if WANTGRAY
		/* [1] */		wContentColor, 0xEEEE, 0xDDDD, 0xDDDD,	// colored background
#else
		/* [1] */		wContentColor, 65535, 65535, 65535,		// white background
#endif
		/* [2] */		wFrameColor, 0, 0, 0,
		/* [3] */		wTextColor, 0, 0, 0,
		/* [4] */		wHiliteColor, 0, 0, 0,
		/* [5] */		wTitleBarColor, 65535, 65535, 65535
	}
};
resource 'DLOG' (128, "Test 3D Button", purgeable) {
	{44, 10, 274, 429},	
	movableDBoxProc,	visible,	nogoAway,	
	0x0,	
	128,	
	"Test saButton"
#ifdef systemSevenOrLater
	, centerMainScreen
#endif
};


resource 'DITL' (128) {
	{
		/* [1] */	{197, 348, 217, 407},		Control		{	enabled,	128		},
		/* [2] */	{167, 348, 187, 407},		Control 	{	enabled,	129		},
		
		
		/* [3] */	{40, 300, 56, 410},			Control 	{	enabled,	130		},
		/* [4] */	{66, 300, 98, 410},			Control 	{	enabled,	131		}, 
		
		/* [5] */	{107, 300, 123, 410},		Control		{	enabled,	132		},
		/* [6] */	{128, 300, 144, 410},		Control		{	enabled,	133		},
	
		/* [7] */	{197, 208, 217, 267},		Control		{	enabled,	150		},
		
		/* [8] */	{40, 160, 56, 290},			Control 	{	enabled,	152		},
		/* [9] */	{66, 160, 98, 290},			Control 	{	enabled,	153		},
		
		/* [10] */	{107, 160, 123, 290},		Control 	{	enabled,	154		},
		/* [11] */	{128, 160, 144, 290},		Control 	{	enabled,	155		},
		
		/* [12] */	{17, 10, 37, 70},			Control		{ 	enabled,	256		},
		/* [13] */	{47, 10, 67, 70},			Control		{ 	enabled,	257		},
		/* [14] */	{77, 10, 97, 70},			Control		{ 	enabled,	258		},
		/* [15] */	{107, 10, 127, 70},			Control		{ 	enabled,	259		},
		/* [16] */	{137, 10, 157, 70},			Control		{ 	enabled,	260		},
		/* [17] */	{167, 10, 187, 70},			Control		{ 	enabled,	261		},
		/* [18] */	{197, 10, 217, 70},			Control		{ 	enabled,	262		},
		
		/* [19] */	{17, 80, 37, 140},			Control		{ 	enabled,	512		},
		/* [20] */	{47, 80, 67, 140},			Control		{ 	enabled,	513		},
		/* [21] */	{77, 80, 97, 140},			Control		{ 	enabled,	514		},
		/* [22] */	{107, 80, 127, 140},		Control		{ 	enabled,	515		},
		/* [23] */	{137, 80, 157, 140},		Control		{ 	enabled,	516		},
		/* [24] */	{167, 80, 187, 140},		Control		{ 	enabled,	517		},
		/* [25] */	{197, 80, 217, 140},		Control		{ 	enabled,	518		},
		
		/* [26] */	{15, 300, 31, 410},			StaticText	{	disabled, 	"System CDEF"	},
		/* [27] */	{15, 160, 31, 290},			StaticText	{	disabled, 	"3D CDEF"	},
	}
};


// make sure the RECTs for the CNTL resources match the DITL rects above or your your
// dialog will 'flash' when it is drawn.

resource 'CNTL' (128) {
	{197, 348, 217, 407},0,	visible,	1,		0,	
	16*CDEF0+pushButProc+useWFont,	0,	"OK"
};
resource 'CNTL' (129) {
	{167, 348, 187, 407},0,	visible,	1,		0,	
	16*CDEF0+pushButProc+useWFont,	0,	"Cancel"
};

resource 'CNTL' (130) {
	{40, 300, 56, 410},	1,	visible,	1,		0,	
	16*CDEF0+checkBoxProc+useWFont,	0,	"CheckBox"
};
resource 'CNTL' (131) {
	{66, 300, 98, 410},	0,	visible,	1,		0,	
	16*CDEF0+checkBoxProc+useWFont,	0,	"2 line\nTitle"
};

resource 'CNTL' (132) {
	{107, 300, 123, 410},1,	visible,	1,		0,	
	16*CDEF0+radioButProc+useWFont,	0,	"RadioButton 1"
};
resource 'CNTL' (133) {
	{128, 300, 144, 410},0,	visible,	1,		0,	
	16*CDEF0+radioButProc+useWFont,	0,	"RadioButton 2"
};


resource 'CNTL' (150) {
	{197, 208, 217, 267},0,	visible,	1,		0,	
	16*CDEF+pushButProc+useWFont+useWBG,	0,	"Disable"
};

resource 'CNTL' (152) {
	{40, 160, 56, 290},	1,	visible,	1,		0,	
	16*CDEF+checkBoxProc+useWFont,	0,	"CheckBox"
};
resource 'CNTL' (153) {
	{66, 160, 98, 290},	0,	visible,	1,		0,	
	16*CDEF+checkBoxProc+useWFont,	0,	"2 line\nTitle"
};

resource 'CNTL' (154) {
	{107, 160, 123, 290},1,	visible,	1,		0,	
	16*CDEF+radioButProc+useWFont,	0,	"RadioButton 1"
};
resource 'CNTL' (155) {
	{128, 160, 144, 290},0,	visible,	1,		0,	
	16*CDEF+radioButProc+useWFont,	0,	"RadioButton 2"
};

resource 'CNTL' (256, purgeable) {
	{17, 10, 37, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Normal"
};

resource 'CNTL' (257, purgeable) {
	{47, 10, 67, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Blue"
};

resource 'CNTL' (258, purgeable) {
	{77, 10, 97, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Red"
};

resource 'CNTL' (259, purgeable) {
	{107, 10, 127, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Green"
};

resource 'CNTL' (260, purgeable) {
	{137, 10, 157, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Purple"
};
resource 'CNTL' (261, purgeable) {
	{167, 10, 187, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Orange"
};
resource 'CNTL' (262, purgeable) {
	{197, 10, 217, 70},	0,	visible,	1,		0,	
	16*CDEF+useWFont,				0,	"Gray"
};


resource 'CNTL' (512, purgeable) {
	{17, 80, 37, 140},		0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Normal"
};

resource 'CNTL' (513, purgeable) {
	{47, 80, 67, 140},		0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Blue"
};

resource 'CNTL' (514, purgeable) {
	{77, 80, 97, 140},		0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Red"
};

resource 'CNTL' (515, purgeable) {
	{107, 80, 127, 140},	0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Green"
};

resource 'CNTL' (516, purgeable) {
	{137, 80, 157, 140},	0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Purple"
};
resource 'CNTL' (517, purgeable) {
	{167, 80, 187, 140},	0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Orange"
};
resource 'CNTL' (518, purgeable) {
	{197, 80, 217, 140},	0,	visible,	1,		0,	
	16*CDEF0+useWFont,				0,	"Gray"
};

resource 'cctb' (257, "Blue", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 0xCCCC,
		/* [2] */	cTextColor, 0, 0, 0xCCCC,
		/* [3] */	cBodyColor, 0xCCCC, -1, -1
	}
};

resource 'cctb' (258, "Red", purgeable) {
	{
		/* [1] */	cFrameColor, 0xEEEE, 0, 0,
		/* [2] */	cTextColor, 0xEEEE, 0, 0,
		/* [3] */	cBodyColor, -1, 0xCCCC, 0xCCCC
	}
};

resource 'cctb' (259, "Green", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0x6666, 0,
		/* [2] */	cTextColor, 0, 0x6666, 0,
		/* [3] */	cBodyColor, 0xCCCC, -1, 0xCCCC
	}
};

resource 'cctb' (260, "Purple", purgeable) {
	{
		/* [1] */	cFrameColor, 0x6666, 0, 0x6666,
		/* [2] */	cTextColor, 0x6666, 0, 0x6666,
		/* [3] */	cBodyColor, 0xCCCC, 0xCCCC, -1
	}
};

resource 'cctb' (261, "Orange", purgeable) {
	{
		/* [1] */	cFrameColor, -1, 0x3333, 0,
		/* [2] */	cTextColor, -1, 0x3333, 0,
		/* [3] */	cBodyColor, -1, 0xCCCC, 0x9999
	}
};

resource 'cctb' (262, "Gray", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 0,
		/* [2] */	cTextColor, 0, 0, 0,
		/* [3] */	cBodyColor, 0xDDDD, 0xDDDD, 0xDDDD
	}
};


resource 'cctb' (513, "Blue", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 0xCCCC,
		/* [2] */	cTextColor, 0, 0, 0xCCCC,
		/* [3] */	cBodyColor, 0xCCCC, -1, -1
	}
};

resource 'cctb' (514, "Red", purgeable) {
	{
		/* [1] */	cFrameColor, 0xEEEE, 0, 0,
		/* [2] */	cTextColor, 0xEEEE, 0, 0,
		/* [3] */	cBodyColor, -1, 0xCCCC, 0xCCCC
	}
};

resource 'cctb' (515, "Green", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0x6666, 0,
		/* [2] */	cTextColor, 0, 0x6666, 0,
		/* [3] */	cBodyColor, 0xCCCC, -1, 0xCCCC
	}
};

resource 'cctb' (516, "Purple", purgeable) {
	{
		/* [1] */	cFrameColor, 0x6666, 0, 0x6666,
		/* [2] */	cTextColor, 0x6666, 0, 0x6666,
		/* [3] */	cBodyColor, 0xCCCC, 0xCCCC, -1
	}
};

resource 'cctb' (517, "Orange", purgeable) {
	{
		/* [1] */	cFrameColor, -1, 0x3333, 0,
		/* [2] */	cTextColor, -1, 0x3333, 0,
		/* [3] */	cBodyColor, -1, 0xCCCC, 0x9999
	}
};

resource 'cctb' (518, "Gray", purgeable) {
	{
		/* [1] */	cFrameColor, 0, 0, 0,
		/* [2] */	cTextColor, 0, 0, 0,
		/* [3] */	cBodyColor, 0xDDDD, 0xDDDD, 0xDDDD
	}
};