/* See the file Distribution for distribution terms.
	(c) Copyright 1994 Ari Halberstadt */

/* This file contains definitions used in resources
	for use with my popup CDEF.

	950601 aih - split out of PopupCDEF.h */

#ifndef POPUP_CDEF_RESOURCES
#define POPUP_CDEF_RESOURCES

/* Version of this library. Useful for compatability between older versions
	of the CDEF when using a newer version of the popup library to manipulate
	the CDEF popups from within a program. The program must first check the
	popup's version before calling any popup library routines. */
#define kPopupVersion						(4)

/* Part codes. */
#define kPopupPartCode						(1)	/* returned when the mouse is in a popup control */
#define kPopupPartSelected					(1)	/* returned when the mouse is released in a menu item */
#define kPopupPartNotSelected				(0)	/* returned when no item was selected from the menu */

/*	Part codes used for specifying colors in a control's color table. */

#define kPopupPartTitleFore				(256)	/* title string */
#define kPopupPartTitleBack				(257)	/* title rectangle */
#define kPopupPartTitleDisabled			(258)	/* disabled title string */

#define kPopupPartItemFore					(259)	/* current item string */
#define kPopupPartItemBack					(260)	/* current item rectangle */
#define kPopupPartItemDisabled			(261)	/* disabled current item string */

#define kPopupPartIconFore					(262) /* current item icon */
#define kPopupPartIconBack					(263) /* background of current item icon */
#define kPopupPartIconDisabled			(264) /* disabled current item icon */

#define kPopupPartTriangleFore			(265)	/* triangle */
#define kPopupPartTriangleBack			(266)	/* background of triangle */
#define kPopupPartTriangleDisabled		(267)	/* disabled triangle */

#define kPopupPartFrameFore				(268)	/* frame around current item */
#define kPopupPartFrameBack				(269)	/* background of frame around current item */
#define kPopupPartFrameDisabled			(270)	/* disabled frame around current item */

#define kPopupPartShadowFore				(271)	/* drop shadow */
#define kPopupPartShadowBack				(272)	/* background of drop shadow */
#define kPopupPartShadowDisabled			(273)	/* disabled drop shadow */

#define kPopupPartDefaultFore				(274)	/* default foreground color */
#define kPopupPartDefaultBack				(275)	/* color to erase empty parts of control */
#define kPopupPartDefaultDisabled		(276)	/* ignored */

/*	When using the popupTypeIn variation code, only the popup's triangle
	is drawn, while the popup's title and current selection are not drawn.
	Type-in popup menus are described in IM-VI, p2-37. */
#define kPopupTypeIn							(2)
#define popupTypeIn							kPopupTypeIn

/* The procIDs for the popup CDEF(s). You can use these values in
	calls to NewControl. This assumes that the resource ID of the CDEF
	is 129. You can use any ID for the CDEF resource, but you will
	have to multiply the ID by 16 to get the procID value to use
	in calls to NewControl. When I created this CDEF, I just went
	and used 129 as the ID, but now realize that 129 is one of the
	most commonly used IDs for a CDEF. You can use a different ID,
	without having to redefine any other constants in your code,
	by simply defining kPopupCDEFID before including this file. */

#ifndef kPopupCDEFID
	#define kPopupCDEFID						(129)
#endif

#define kPopupProcID							(kPopupCDEFID * 16)

#define kPopupCDEFIDFat						(kPopupCDEFID)
#define kPopupCDEFID68K						(kPopupCDEFID + 1)
#define kPopupCDEFIDPPC						(kPopupCDEFID + 2)
#define kPopupProcIDFat						(kPopupCDEFIDFat * 16)
#define kPopupProcID68K						(kPopupCDEFID68K * 16)
#define kPopupProcIDPPC						(kPopupCDEFIDPPC * 16)

#endif /* POPUP_CDEF_RESOURCES */
