/*	See the file Distribution for distribution terms.
	(c) Copyright 1994 Ari Halberstadt */

/*---------------------------------------------------------------------------*/
/* Resources for the Popup Demo application. */
/*---------------------------------------------------------------------------*/

/* Defining POPUP_CDEF_RESOURCE_ONLY allows us to include "PopupCDEF.h",
	which defines various constants. */
#define POPUP_CDEF_RESOURCE_ONLY		(1)

/*	Defining SystemSevenOrLater allows us to use System 7 dependent resource
	features, like automatic positioning of windows. */
#define SystemSevenOrLater				(1)

#include <SysTypes.r>
#include <Types.r>
#include "PopupCDEF.h"

/*---------------------------------------------------------------------------*/
/*	Resource IDs. */
/*---------------------------------------------------------------------------*/

#define kDialogID							(128)

#define kPopupIDFont						(128)
#define kPopupIDSize						(129)
#define kPopupIDStyle					(130)
#define kPopupIDAlign					(131)
#define kPopupIDIcons					(132)
#define kPopupIDLongTitle				(133)
#define kPopupIDRightAligned			(134)
#define kPopupIDWindowFont				(135)
#define kPopupIDDisabledItem			(136)
#define kPopupIDDisabled				(137)
#define kPopupIDNoTitle					(138)
#define kPopupIDColor					(139)

#define kIconID							(1)
#define kSmallIconIDLeft				(1)
#define kSmallIconIDCenter				(2)
#define kSmallIconIDRight				(3)
#define kSmallIconIDJustify			(4)
#define kColorIconID						(44)

/*---------------------------------------------------------------------------*/
/* Control sizes. The width and height of the rectangle of a 'CNTL' resource
	must be the same as the width and height of the rectangle of a 'DITL'
	item. To ensure that the width and height are the same, we define these
	constants. */
/*---------------------------------------------------------------------------*/

#define kControlFontW					(250)
#define kControlFontH					(20)

#define kControlSizeW					(22)
#define kControlSizeH					(20)

#define kControlStyleW					(250)
#define kControlStyleH					(24)

#define kControlAlignW					(200)
#define kControlAlignH					(24)

#define kControlIconsW					(200)
#define kControlIconsH					(64)

#define kControlLongTitleW				(250)
#define kControlLongTitleH				(38)

#define kControlRightAlignedW			(250)
#define kControlRightAlignedH			(24)

#define kControlWindowFontW			(200)
#define kControlWindowFontH			(20)

#define kControlDisabledItemW			(250)
#define kControlDisabledItemH			(20)

#define kControlDisabledW				(200)
#define kControlDisabledH				(22)

#define kControlNoTitleW				(200)
#define kControlNoTitleH				(20)

#define kControlColorW					(250)
#define kControlColorH					(64)

/*---------------------------------------------------------------------------*/
/* Colors. */
/*---------------------------------------------------------------------------*/

#define kRGB100					65535
#define kRGB075					49152
#define kRGB050					32768
#define kRGB025					16384
#define kRGB000					0

#define kRGBColorWhite			kRGB100,	kRGB100,	kRGB100
#define kRGBColorGray75			kRGB075,	kRGB075,	kRGB075
#define kRGBColorGray50			kRGB050,	kRGB050,	kRGB050
#define kRGBColorGray25			kRGB025,	kRGB025,	kRGB025
#define kRGBColorBlack			kRGB000,	kRGB000,	kRGB000

#define kRGBColorRed				kRGB100,	kRGB000,	kRGB000
#define kRGBColorRed75			kRGB075,	kRGB000,	kRGB000
#define kRGBColorRed50			kRGB050,	kRGB000,	kRGB000
#define kRGBColorRed25			kRGB025,	kRGB000,	kRGB000

#define kRGBColorGreen			kRGB000,	kRGB100,	kRGB000
#define kRGBColorGreen75		kRGB000,	kRGB075,	kRGB000
#define kRGBColorGreen50		kRGB000,	kRGB050,	kRGB000
#define kRGBColorGreen25		kRGB000,	kRGB025,	kRGB000

#define kRGBColorBlue			kRGB000,	kRGB000,	kRGB100
#define kRGBColorBlue75			kRGB000,	kRGB000,	kRGB075
#define kRGBColorBlue50			kRGB000,	kRGB000,	kRGB050
#define kRGBColorBlue25			kRGB000,	kRGB000,	kRGB025

#define kRGBColorCyan			kRGB000,	kRGB100,	kRGB100
#define kRGBColorCyan75			kRGB000,	kRGB075,	kRGB075
#define kRGBColorCyan50			kRGB000,	kRGB050,	kRGB050
#define kRGBColorCyan25			kRGB000,	kRGB025,	kRGB025

#define kRGBColorMagenta		kRGB100,	kRGB000,	kRGB100
#define kRGBColorMagenta75		kRGB075,	kRGB000,	kRGB075
#define kRGBColorMagenta50		kRGB050,	kRGB000,	kRGB050
#define kRGBColorMagenta25		kRGB025,	kRGB000,	kRGB025

#define kRGBColorYellow			kRGB100,	kRGB100,	kRGB000
#define kRGBColorYellow75		kRGB075,	kRGB075,	kRGB000
#define kRGBColorYellow50		kRGB050,	kRGB050,	kRGB000
#define kRGBColorYellow25		kRGB025,	kRGB025,	kRGB000

/*---------------------------------------------------------------------------*/
/* Controls. */
/*---------------------------------------------------------------------------*/

resource 'CNTL' (kPopupIDFont, "Font popup", purgeable) {
	{ 0, 0, kControlFontH, kControlFontW },
	0,
	visible,
	54,
	kPopupIDFont,
	kPopupProcID + popupFixedWidth + popupUseAddResMenu,
	'FOND',
	"Font:"
};

resource 'CNTL' (kPopupIDSize, "Size popup", purgeable) {
	{ 0, 0, kControlSizeH, kControlSizeW },
	0,
	visible,
	0,
	kPopupIDSize,
	kPopupProcID + popupFixedWidth + popupTypeIn,
	0,
	""
};

resource 'CNTL' (kPopupIDStyle, "Style popup", purgeable) {
	{ 0, 0, kControlStyleH, kControlStyleW },
	popupTitleItalic + popupTitleUnderline,
	visible,
	54,
	kPopupIDStyle,
	kPopupProcID + popupFixedWidth,
	0,
	"Style:"
};

resource 'CNTL' (kPopupIDAlign, "Align popup", purgeable) {
	{ 0, 0, kControlAlignH, kControlAlignW },
	0,
	visible,
	0,
	kPopupIDAlign,
	kPopupProcID + popupFixedWidth,
	0,
	"Align:"
};

resource 'CNTL' (kPopupIDIcons, "Icons popup", purgeable) {
	{ 0, 0, kControlIconsH, kControlIconsW },
	0,
	visible,
	54,
	kPopupIDIcons,
	kPopupProcID + popupFixedWidth,
	0,
	"Icons:"
};

resource 'CNTL' (kPopupIDLongTitle, "Long title popup", purgeable) {
	{ 0, 0, kControlLongTitleH, kControlLongTitleW },
	0,
	visible,
	0,
	kPopupIDLongTitle,
	kPopupProcID + popupFixedWidth,
	0,
	"Really long title that's too long to display:"
};

resource 'CNTL' (kPopupIDRightAligned, "Right aligned popup", purgeable) {
	{ 0, 0, kControlRightAlignedH, kControlRightAlignedW },
	popupTitleUnderline + popupTitleRightJust,
	visible,
	0,
	kPopupIDRightAligned,
	kPopupProcID + popupFixedWidth,
	0,
	"Right Aligned"
};

resource 'CNTL' (kPopupIDWindowFont, "Window font popup", purgeable) {
	{ 0, 0, kControlWindowFontH, kControlWindowFontW },
	0,
	visible,
	0,
	kPopupIDWindowFont,
	kPopupProcID + popupFixedWidth + popupUseWFont,
	0,
	"Window Font:"
};

resource 'CNTL' (kPopupIDDisabledItem, "Disabled item popup", purgeable) {
	{ 0, 0, kControlDisabledItemH, kControlDisabledItemW },
	0,
	visible, 
	0,
	kPopupIDDisabledItem,
	kPopupProcID,
	0,
	"Disabled Item:"
};

resource 'CNTL' (kPopupIDDisabled, "Disabled popup", purgeable) {
	{ 0, 0, kControlDisabledH, kControlDisabledW },
	0,
	visible,
	0,
	kPopupIDDisabled,
	kPopupProcID + popupFixedWidth,
	0,
	"Disabled:"
};

resource 'CNTL' (kPopupIDNoTitle, "No title popup", purgeable) {
	{ 0, 0, kControlNoTitleH, kControlNoTitleW },
	0,
	visible,
	0,
	kPopupIDNoTitle,
	kPopupProcID + popupFixedWidth,
	0,
	""
};

resource 'CNTL' (kPopupIDColor, "Color popup", purgeable) {
	{ 0, 0, kControlColorH, kControlColorW },
	0,
	visible,
	0,
	kPopupIDColor,
	kPopupProcID,
	0,
	"Color Menu:"
};

/*---------------------------------------------------------------------------*/
/* Control color tables. */
/*---------------------------------------------------------------------------*/

resource 'cctb' (kPopupIDDisabled, "Popup control color table", purgeable) {
	{		
		kPopupPartTitleFore,				kRGBColorRed,
		kPopupPartTitleBack,				kRGBColorCyan,
		kPopupPartTitleDisabled,		kRGBColorGray50,

		kPopupPartItemFore,				kRGBColorGreen,
		kPopupPartItemBack,				kRGBColorMagenta,
		kPopupPartItemDisabled,			kRGBColorGray50,

		kPopupPartIconFore,				kRGBColorBlue,
		kPopupPartIconBack,				kRGBColorYellow,
		kPopupPartIconDisabled,			kRGBColorGray50,

		kPopupPartTriangleFore,			kRGBColorGreen50,
		kPopupPartTriangleDisabled,	kRGBColorGray50,

		kPopupPartFrameFore,				kRGBColorBlack,
		kPopupPartFrameDisabled,		kRGBColorGray50,

		kPopupPartShadowFore,			kRGBColorBlue75,
		kPopupPartShadowDisabled,		kRGBColorGray25,
	}
};

/*---------------------------------------------------------------------------*/
/* Menus. */
/*---------------------------------------------------------------------------*/

resource 'MENU' (kPopupIDFont, "Font popup") {
	kPopupIDFont, textMenuProc, allEnabled, enabled, "Font",
	{
		/* no items */
	}
};

resource 'MENU' (kPopupIDSize, "Size popup") {
	kPopupIDSize, textMenuProc, allEnabled, enabled, "Size",
	{
		/* [1] */ "9", noIcon, noKey, noMark, plain,
		/* [2] */ "10", noIcon, noKey, noMark, plain,
		/* [3] */ "12", noIcon, noKey, noMark, plain,
		/* [4] */ "14", noIcon, noKey, noMark, plain,
		/* [5] */ "18", noIcon, noKey, noMark, plain,
		/* [6] */ "24", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (kPopupIDStyle, "Style popup") {
	kPopupIDStyle, textMenuProc, allEnabled, enabled, "Style",
	{
		/* [1] */ "Plain", noIcon, "T", noMark, plain,
		/* [2] */ "Bold", noIcon, "B", noMark, bold,
		/* [3] */ "Italic", noIcon, "I", noMark, italic,
		/* [4] */ "Underline", noIcon, "U", noMark, underline,
		/* [5] */ "Outline", noIcon, noKey, noMark, outline,
		/* [6] */ "Shadow", noIcon, noKey, noMark, shadow,
		/* [7] */ "Condensed", noIcon, noKey, noMark, condense,
		/* [8] */ "Extended", noIcon, noKey, noMark, extend
	}
};

resource 'MENU' (kPopupIDAlign, "Align popup") {
	kPopupIDAlign, textMenuProc, allEnabled, enabled, "Alignment",
	{
		/* [1] */ "Left", kSmallIconIDLeft, "\0x1E", noMark, plain,
		/* [2] */ "Center", kSmallIconIDCenter, "\0x1E", noMark, plain,
		/* [3] */ "Right", kSmallIconIDRight, "\0x1E", noMark, plain,
		/* [4] */ "Justify", kSmallIconIDJustify, "\0x1E", noMark, plain
	}
};

resource 'MENU' (kPopupIDIcons, "Icons popup") {
	kPopupIDIcons, textMenuProc, allEnabled, enabled, "Icons",
	{
		/* [1] */ "Color Icon", kColorIconID, noKey, noMark, plain,
		/* [2] */ "Regular icon", kIconID, noKey, noMark, plain,
		/* [3] */ "Reduced icon", kIconID, "\0x1D", noMark, plain,
		/* [4] */ "Small icon", kSmallIconIDLeft, "\0x1E", noMark, plain
	}
};

resource 'MENU' (kPopupIDLongTitle, "Long title popup") {
	kPopupIDLongTitle, textMenuProc, allEnabled, enabled, "Icons",
	{
		/* [1] */ "Big icon", kIconID, noKey, noMark, plain,
		/* [2] */ "Reduced icon", kIconID, "\0x1D", noMark, plain,
		/* [3] */ "Small icon", kSmallIconIDLeft, "\0x1E", noMark, plain
	}
};

resource 'MENU' (kPopupIDRightAligned, "Right aligned popup") {
	kPopupIDRightAligned, textMenuProc, allEnabled, enabled, "Alignment",
	{
		/* [1] */ "Left", kSmallIconIDLeft, "\0x1E", noMark, plain,
		/* [2] */ "Center", 2, "\0x1E", noMark, plain,
		/* [3] */ "Right", 3, "\0x1E", noMark, plain,
		/* [4] */ "Justify", 4, "\0x1E", noMark, plain
	}
};

resource 'MENU' (kPopupIDWindowFont, "Window font popup") {
	kPopupIDWindowFont, textMenuProc, allEnabled, enabled, "Style",
	{
		/* [1] */ "Plain", noIcon, noKey, noMark, plain,
		/* [2] */ "Bold", noIcon, "B", noMark, bold,
		/* [3] */ "Italic", noIcon, "I", noMark, italic,
		/* [4] */ "Underline", noIcon, "U", noMark, underline,
		/* [5] */ "Outline", noIcon, noKey, noMark, outline,
		/* [6] */ "Shadow", noIcon, noKey, noMark, shadow,
		/* [7] */ "Condensed", noIcon, noKey, noMark, condense,
		/* [8] */ "Extended", noIcon, noKey, noMark, extend
	}
};

resource 'MENU' (kPopupIDDisabledItem, "Disabled item popup") {
	kPopupIDDisabledItem, textMenuProc, 0x7FFFFFFE, enabled, "Disabled Item",
	{	
		/* [1] */ "Disabled Item", noIcon, noKey, noMark, plain,
		/* [2] */ "Enabled Item", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (kPopupIDDisabled, "Disabled popup") {
	kPopupIDDisabled, textMenuProc, allEnabled, enabled, "Disabled",
	{
		/* [ 1] */ "One", kSmallIconIDLeft, "\0x1E", noMark, plain,
		/* [ 2] */ "Two", noIcon, noKey, noMark, plain,
		/* [ 3] */ "Three", noIcon, noKey, noMark, plain,
		/* [ 4] */ "Four", noIcon, noKey, noMark, plain,
		/* [ 5] */ "Five", noIcon, noKey, noMark, plain,
		/* [ 6] */ "Six", noIcon, noKey, noMark, plain,
		/* [ 7] */ "Seven", noIcon, noKey, noMark, plain,
		/* [ 8] */ "Eight", noIcon, noKey, noMark, plain,
		/* [ 9] */ "Nine", noIcon, noKey, noMark, plain,
		/* [10] */ "Ten", noIcon, noKey, noMark, plain,
		/* [11] */ "Eleven", noIcon, noKey, noMark, plain,
		/* [12] */ "Twelve", noIcon, noKey, noMark, plain,
		/* [13] */ "Thirteen", noIcon, noKey, noMark, plain,
		/* [14] */ "Fourteen", noIcon, noKey, noMark, plain,
		/* [15] */ "Fifteen", noIcon, noKey, noMark, plain,
		/* [16] */ "Sixteen", noIcon, noKey, noMark, plain,
		/* [17] */ "Seventeen", noIcon, noKey, noMark, plain,
		/* [18] */ "Eighteen", noIcon, noKey, noMark, plain,
		/* [19] */ "Nineteen", noIcon, noKey, noMark, plain,
		/* [20] */ "Twenty", noIcon, noKey, noMark, plain,
		/* [21] */ "Twenty One", noIcon, noKey, noMark, plain,
		/* [22] */ "Twenty Two", noIcon, noKey, noMark, plain,
		/* [23] */ "Twenty Three", noIcon, noKey, noMark, plain,
		/* [24] */ "Twenty Four", noIcon, noKey, noMark, plain,
		/* [25] */ "Twenty Five", noIcon, noKey, noMark, plain,
		/* [26] */ "Twenty Six", noIcon, noKey, noMark, plain,
		/* [27] */ "Twenty Seven", noIcon, noKey, noMark, plain,
		/* [28] */ "Twenty Eight", noIcon, noKey, noMark, plain,
		/* [29] */ "Twenty Nine", noIcon, noKey, noMark, plain,
		/* [30] */ "Thirty", noIcon, noKey, noMark, plain,
		/* [31] */ "Thirty One", noIcon, noKey, noMark, plain,
		/* [32] */ "Thirty Two", noIcon, noKey, noMark, plain,
		/* [33] */ "Thirty Three", noIcon, noKey, noMark, plain,
		/* [34] */ "Thirty Four", noIcon, noKey, noMark, plain,
		/* [35] */ "Thirty Five", noIcon, noKey, noMark, plain,
		/* [36] */ "Thirty Six", noIcon, noKey, noMark, plain,
		/* [37] */ "Thirty Seven", noIcon, noKey, noMark, plain,
		/* [38] */ "Thirty Eight", noIcon, noKey, noMark, plain,
		/* [39] */ "Thirty Nine", noIcon, noKey, noMark, plain,
		/* [40] */ "Forty", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (kPopupIDNoTitle, "No title popup") {
	kPopupIDNoTitle, textMenuProc, allEnabled, enabled, "No Title",
	{
		/* [ 1] */ "This", noIcon, noKey, noMark, plain,
		/* [ 2] */ "Popup", noIcon, noKey, noMark, plain,
		/* [ 3] */ "Menu", noIcon, noKey, noMark, plain,
		/* [ 4] */ "Control", noIcon, noKey, noMark, plain,
		/* [ 5] */ "Does", noIcon, noKey, noMark, plain,
		/* [ 6] */ "Not", noIcon, noKey, noMark, plain,
		/* [ 7] */ "Have", noIcon, noKey, noMark, plain,
		/* [ 8] */ "A", noIcon, noKey, noMark, plain,
		/* [ 9] */ "Title", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (kPopupIDColor, "Color popup") {
	kPopupIDColor, textMenuProc, 0x7FFFFFFC, enabled, "Color Menu",
	{
		/* [ 1] */ "Disabled Color Icon", kColorIconID, noKey, noMark, plain,
		/* [ 2] */ "Disabled B&W Icon", kIconID, noKey, noMark, plain,
		/* [ 3] */ "Enabled Default Color", noIcon, noKey, noMark, plain,
		/* [ 4] */ "Black", noIcon, noKey, noMark, plain,
		/* [ 5] */ "Red", noIcon, noKey, noMark, plain,
		/* [ 6] */ "Orange", noIcon, noKey, noMark, plain,
		/* [ 7] */ "Yellow", noIcon, noKey, noMark, plain,
		/* [ 8] */ "Big Color Icon", kColorIconID, noKey, noMark, plain,
		/* [ 9] */ "Blue Small Icon", kSmallIconIDLeft, "\0x1E", noMark, plain,
		/* [10] */ "Purple Icon", kIconID, noKey, noMark, plain
	}
};

/*---------------------------------------------------------------------------*/
/* Menu color tables. */
/*---------------------------------------------------------------------------*/

resource 'mctb' (kPopupIDColor, "Popup menu color table") {
	{	/* [ 1] */ kPopupIDColor, 4,
			{	/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	0, 0, 0,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 2] */ kPopupIDColor, 5,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	56797, 0, 0,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 3] */ kPopupIDColor, 6,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	65535, 26214, 0,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 4] */ kPopupIDColor, 7,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	65535, 65535, 0,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 5] */ kPopupIDColor, 8,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	0, 26214, 0,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 6] */ kPopupIDColor, 9,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	0, 0, 56797,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 7] */ kPopupIDColor, 10,
			{
				/* [ 1] */ 	65535, 0, 52428,
				/* [ 2] */ 	13107, 0, 39321,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			},
		/* [ 8] */ kPopupIDColor, 0,
			{
				/* [ 1] */ 	0, 26214, 0,
				/* [ 2] */ 	65535, 65535, 65535,
				/* [ 3] */ 	65535, 0, 52428,
				/* [ 4] */ 	0, 39321, 65535
			}
	}
};

/*---------------------------------------------------------------------------*/
/* Dialogs. */
/*---------------------------------------------------------------------------*/

resource 'DLOG' (kDialogID, "Popup demo", purgeable) {
	{40, 4, 337, 488},
	documentProc,
	invisible,
	noGoAway,
	0x0,
	kDialogID,
	"Popup Demo",
	centerMainScreen
};

resource 'DITL' (kDialogID, "Popup demo", purgeable) {
	{

		/* [ 1] */ {4, 422, 24, 480},
			Button { enabled, "Quit" },

		/* [ 2] */ {52, 8, 52 + kControlFontH, 8 + kControlFontW },
			Control { enabled, kPopupIDFont },

		/* [ 3] */ {54, 277, 70, 316},
			StaticText { disabled, "Size:" },

		/* [ 4] */ {54, 322, 70, 379},
			EditText { enabled, "999" },

		/* [ 5] */ {52, 385, 52 + kControlSizeH, 385 + kControlSizeW },
			Control { enabled, kPopupIDSize },

		/* [ 6] */ {80, 8, 80 + kControlStyleH, 8 + kControlStyleW },
			Control { enabled, kPopupIDStyle },
	
		/* [ 7] */ {80, 272, 80 + kControlAlignH, 272 + kControlAlignW },
			Control { enabled, kPopupIDAlign },

		/* [ 8] */ {148, 8, 148 + kControlLongTitleH, 8 + kControlLongTitleW },
			Control { enabled, kPopupIDLongTitle },
	
		/* [ 9] */ {228, 272, 228 + kControlIconsH, 272 + kControlIconsW },
			Control { enabled, kPopupIDIcons },

		/* [10] */ {112, 8, 112 + kControlRightAlignedH, 8 + kControlRightAlignedW },
			Control { enabled, kPopupIDRightAligned },

		/* [11] */ {112, 272, 112 + kControlWindowFontH, 272 + kControlWindowFontW },
			Control { enabled, kPopupIDWindowFont },

		/* [12] */ {196, 8, 196 + kControlDisabledItemH, 8 + kControlDisabledItemW },
			Control { enabled, kPopupIDDisabledItem },

		/* [13] */ {168, 280, 168 + kControlDisabledH, 280 + kControlDisabledW },
			Control { disabled, kPopupIDDisabled },

		/* [14] */ {196, 272, 196 + kControlNoTitleH, 272 + kControlNoTitleW },
			Control { enabled, kPopupIDNoTitle },

		/* [15] */ {228, 8, 228 + kControlColorH, 8 + kControlColorW },
			Control { enabled, kPopupIDColor },

		/* [16] */ {148, 272, 148 + 20, 272 + 200 },
			CheckBox { enabled, "Enable Popup Menu" },

		/* [17] */ {4, 8, 43, 407}, StaticText { disabled,
			"",
		}
	}
};

resource 'dctb' (kDialogID, "Popup demo", purgeable) {
	{	/* causes dialog manager to create a color dialog */ }
};

/*---------------------------------------------------------------------------*/
/* Finder resources. */
/*---------------------------------------------------------------------------*/

resource 'vers' (1, purgeable) {
	0x1,
	0x0,
	beta,
	0x5,
	verUS,
	"1.0b5",
	"1.0b5,  1994 by Ari Halberstadt.\n"
};

/*---------------------------------------------------------------------------*/
/* Process Manager resources. For a native PowerPC version of the
	application, this would include a 'cfrg' resource. */
/*---------------------------------------------------------------------------*/

resource 'SIZE' (0, purgeable) {
	reserved,
	ignoreSuspendResumeEvents,
	reserved,
	canBackground,
	needsActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	386 * 1024,
	386 * 1024,
};
