#pragma once
/*****
 *
 *	WindowInt.h
 *
 *	This is a support file for "Grant's CGI Framework".
 *	Please see the license agreement that accompanies the distribution package
 *	for licensing details.
 *
 *	Copyright 1995 by Grant Neufeld
 *	grant@acm.com
 *	http://arpp1.carleton.ca/grant/
 *
 *****/

#include "MyConfiguration.h"
#if kCompileWithForeground

/***  CONSTANT DECLARATIONS  ***/

#define kMinWindSize	48


/***  TYPE DECLARATIONS  ***/

typedef enum
{
	Window_UNKNOWN,				/* unrecognized type of window */
	
	Window_none,				/* not a window */
	Window_dlgModal,			/* modal dialog */
	Window_dlgMoveableModal,	/* moveable modal dialog */
	Window_dlgModeless,			/* modeless dialog */
	Window_about,				/* about box */
	Window_DA,					/* desk accessory window */
	
	Window_Application			/* custom application window */
} window_type;
/*
Window_UNKNOWN
Window_none
Window_dlgModal
Window_dlgMoveableModal
Window_about
Window_DA
Window_Application
*/
	
typedef struct
{
	window_type		wType;
	Boolean			scrollbars;
	Handle			dataHdl;
} windowInfo;

typedef windowInfo** windowInfoHdl;


/***  FUNCTION PROTOTYPES  ***/

	void			WindowMenuClose		( short );
	
	void			WindowActivate		( WindowPtr, Boolean, const EventRecord * );
	void			WindowUpdate		( WindowPtr );
	void 			WindowContentClick	( WindowPtr, const EventRecord *, Boolean * );
	void			WindowZoomBox		( WindowPtr, short );
	void 			WindowGrow			( WindowPtr, Point );
	
	Boolean			WindowClose			( WindowPtr, short, Boolean );
	Boolean			WindowCloseAll		( Boolean );
	
	window_type		WindowType			( WindowPtr );
	
	Boolean			WindowNewSetInfo	( WindowPtr, window_type, Boolean, Handle );
	windowInfoHdl	WindowNewInfoHdl	( window_type, Boolean, Handle );
	void			WindowSetInfoHdl	( WindowPtr, windowInfoHdl );
	windowInfoHdl	WindowGetInfoHdl	( WindowPtr );
	void			WindowDisposeInfoHdl	( WindowPtr );
	Handle			WindowGetDataHdl	( WindowPtr );
	
/***  EXTERNAL USER DEFINED FUNCTIONS  ***/

	OSErr			MyCloseWindow		( WindowPtr );
	void			MyActivateWindow	( WindowPtr, Boolean );
	void			MyUpdateWindow		( WindowPtr );
	void			MyClickInWindow		( WindowPtr, Point, Boolean * );


#endif	/* kCompileWithForeground */

/***** EOF *****/
