

/*
 * Horizontal and vertical ratios for positioning the dialogs on the screen
 * according the Apple's (current) Human Interface Guidelines.
 */

# define	horizRatio		FixRatio (1, 2)
# define	vertRatio		FixRatio (1, 5)


#define	helpTextRes		1000	/* help text resource number */
#define	aboutAlrtRes	1000	/* About... alert resource number */
#define launchSetupDlog	1001	/* Launch Setup... dialog resource number */


typedef enum					/* Menu resource numbers */
{
	fileMenuRes = 1000,
	editMenuRes,
	logMenuRes
};


typedef enum					/* Window resource numbers */
{
	logWindRes = 1000,
	helpWindRes,
	selectWindRes
};


typedef enum			/* File menu item numbers */
{
	showLog = 1,	/* make windows visible/bring to front */
	showHelp,
	showSelect,
	/* --- */
	launchSetup = 5,
	launchApp,
	/* --- */
	quit = 8
};


typedef enum				/* Edit menu item numbers */
{
	undo = 1,
	/* --- */
	cut = 3,
	copy,
	paste,
	clear
};


typedef enum				/* Log menu item numbers */
{
	logEvents = 1,		/* whether events are logged */
	excludeLWind,
	/* --- */
	flushLog = 4,		/* flush log output */
	/* --- */
	wrapStyle = 6,		/* word wrap or not */
	/* --- */
	leftJust = 8,		/* justification */
	centerJust,
	rightJust,
	/* --- */
	small = 12,			/* text size */
	medium,
	large,
	/* --- */
	top = 16,			/* scroll home */
	bottom				/* scroll to bottom */
};

extern Boolean		launchInBackground;
extern Boolean		terminateOnLaunch;


void LaunchSetupDialog (void);
