{ Metrowerks Pascal interface specification for TransDisplay }
{ for:       TransDisplay 3.11 }
{ last edit: 07 Oct 95 }

{----------------------------------------------------------------------------}
unit TransDisplay;
{----------------------------------------------------------------------------}

interface

USES
	Windows, TextEdit;

{----------------------------------------------------------------------------}
	type
{----------------------------------------------------------------------------}

{ Procedure type below is equivalenced to ProcPtr.  It's used so }
{ that procedure specifications will read more similarly to their }
{ C counterparts.  The comment preceding the type definition shows how }
{ activate notfication procedures should be written. }

		{ procedure Activate (active:Boolean); }
		TDispActivateProcPtr = ProcPtr;

{----------------------------------------------------------------------------}
{ Interface routines }
{----------------------------------------------------------------------------}

	function NewDWindow (bounds: Rect;
									title: Str255;
									visible: Boolean;
									behind: WindowPtr;
									goAway: Boolean;
									refCon: LongInt): WindowPtr;
	function GetNewDWindow (resourceNum: Integer;
									behind: WindowPtr): WindowPtr;
	function IsDWindow (wind: WindowPtr): Boolean;
	function GetDWindowTE (wind: WindowPtr): TEHandle;
	procedure SetDWindowStyle (wind: WindowPtr;
									font: Integer;
									size: Integer;
									wrap: Integer;
									just: Integer);
	procedure SetDWindowPos (wind: WindowPtr;
									lineNum: Integer);
	procedure SetDWindowNotify (wind: WindowPtr;
									p: TDispActivateProcPtr);
	procedure SetDWindowFlush (wind: WindowPtr;
									maxText: LongInt;
									flushAmt: LongInt);
	procedure SetDWindow (wind: WindowPtr);
	function GetDWindow: WindowPtr;
	procedure FlushDWindow (wind: WindowPtr;
									byteCount: LongInt);

	procedure DisplayText (text: Ptr;
									len: LongInt);
	procedure DisplayString (str: Str255);
	procedure DisplayCString (str: Ptr);	{ not useful from within Pascal }
	procedure DisplayLong (l: LongInt);
	procedure DisplayShort (i: Integer);
	procedure DisplayChar (c: char);
	procedure DisplayLn;
	procedure DisplayBoolean (b: Boolean);
	procedure DisplayHexChar (c: char);
	procedure DisplayHexShort (i: Integer);
	procedure DisplayHexLong (l: LongInt);
	procedure DisplayOSType (theType: OSType);


implementation
end.