#ifndef DISPLAY_LIST_DEFINED
#define DISPLAY_LIST_DEFINED

#include <gl/gl.h>

enum grNode_types {
    TRANSLATE,
    TRANSLATEP,
    ROTATE,
    SCALE,
    SURFACE_MATERIAL,
    DRAW_OBJECT,
    SUBLIST
};

typedef struct grNode_struct {
    int type;
    struct grNode_struct *next;
    union {
        float *(angles[3]);
        float translates[3];
        float *translatesp;
        float *scales;
        int material_index;
        Object *object;
        struct Display_list_struct *sublist;
    } info;
} grNode;

typedef struct Display_list_struct {
    struct grNode_struct *first;
    struct grNode_struct *last;
} Display_list;

extern void
init_display_list(Display_list *display_list);

extern void
add_translate(Display_list *display_list, float x, float y, float z);

extern void
add_translatep(Display_list *display_list, float *p);

extern void
add_rotate(Display_list *display_list, float *angle_x, float *angle_y,
                                                        float *angle_z);

extern void
add_scale(Display_list *display_list, float *scales);

extern void
add_material(Display_list *display_list, int material_index);

extern void
add_object(Display_list *display_list, Object *object);

extern void
add_sublist(Display_list *display_list, Display_list *sublist);

extern void
do_display_list(Display_list *display_list);

#endif /* DISPLAY_LIST_DEFINED */
