/****************************************************************************/
/**                                                                        **/
/**  This function safely allocates n bytes of dynamic memory by checking  **/
/**  the success of malloc().  The function exits with an error if the     **/
/**  allocation was unsuccessful.                                          **/
/**                                                                        **/
/****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

void *
emalloc(unsigned int n)
{
    void *ptr;

    ptr = (void *) malloc(n);
    if ( ptr == NULL ) {
        fprintf(stderr,"emalloc: Can't allocate %d bytes.\n", n);
        exit(EXIT_FAILURE);
    }
    return ptr;
}
