#ifndef __MY_EDITOR_LISTS_H__
#define __MY_EDITOR_LISTS_H__

#ifdef __cplusplus
extern "C" {
#endif

extern	void InitTheEditorLists(void);
extern	ListHandle GetGroupListHandle(void);
extern	ListHandle GetBoardListHandle(void);
extern	void GetGroupListRect(Rect *theRect);
extern	void GetBoardListRect(Rect *theRect);
extern	Boolean GroupListActiveQQ(void);
extern	Boolean BoardListActiveQQ(void);
extern	Boolean HighlightedBoardLockedQQ(void);
extern	Boolean SetHighlightedBoardLocked(Boolean isLocked);
extern	void SetGroupListActive(Boolean redraw);
extern	void SetBoardListActive(Boolean redraw);
extern	void SetHighlightedGroup(short refNum);
extern	void SetHighlightedBoard(short boardNum);
extern	short GetNumberOfGroups(void);
extern	short GetNumberOfBoards(void);
extern	short GetNumberOfVisibleGroups(void);
extern	short GetNumberOfVisibleBoards(void);
extern	short GetHighlightedGroup(void);
extern	short GetHighlightedBoard(void);
extern	void GetIndGroupName(Str255 theStr, short index);
extern	void GetIndBoardName(Str255 theStr, short index);
extern	void GetHighlightedGroupName(Str255 theStr);
extern	void GetHighlightedBoardName(Str255 theStr);
extern	Boolean DeleteHighlightedGroup(void);
extern	Boolean DeleteHighlightedBoard(void);
extern	void AddGroupToList(Str255 theStr, Boolean autoSelect);
extern	void AddBoardToList(Str255 theStr, Boolean isLocked, Boolean autoSelect);
extern	void EditGroupInList(short index, Str255 newStr);
extern	void EditBoardInList(short index, Str255 newStr, Boolean isLocked);
extern	void SetEditorListRects(WindowRef theWindow, short hSpace, short vSpace, short headerHeight);
extern	void CreateEditorLists(WindowRef theWindow);
extern	OSErr BuildGroupListHandle(FSSpec *theFS, Boolean redraw);
extern	OSErr BuildBoardListHandle(FSSpec *theFS, Boolean redraw);
extern	void UpdateEditorLists(WindowRef theWindow);
extern	void ResizeEditorLists(WindowRef theWindow, short hSpace, short vSpace, short headerHeight);
extern	void GetGrowSizeTheLists(Rect *sizeRect, short hSpace, short vSpace, short headerHeight);
extern	void DisposeEditorLists(void);

#ifdef __cplusplus
}
#endif

#endif
