/**********************************************************
 * defines?
 **********************************************************/
#define kVersion 150

/**********************************************************
 * cool macros
 **********************************************************/
#define Bit(foo) (1L << (foo))

/**********************************************************
 * typedefs
 **********************************************************/

typedef pascal short (*SEProcPtr) (EventRecord *);
typedef pascal void (*ICProcPtr) (void);
typedef pascal void (*DMBProcPtr) (void);
typedef pascal void (*ERProcPtr) (Rect *);
typedef pascal void (*EOProcPtr) (Rect *);
typedef pascal void (*EGProcPtr) (RgnHandle);
typedef pascal void (*STProcPtr) (void);

typedef struct PatchGlobals {
	short			pgVersion;			// our version number
	SEProcPtr		pgOldSE;			// address of old SystemEvent
	ICProcPtr		pgOldIC;			// address of old InitCursor
	DMBProcPtr		pgOldDMB;			// address of old DrawMenuBar
	ERProcPtr		pgOldER;			// address of old EraseRect
	EOProcPtr		pgOldEO;			// address of old EraseOval
	EGProcPtr		pgOldEG;			// address of old EraseRgn
	STProcPtr		pgOldST;			// address of old SystemTask
	Boolean			pgSaverOn,			// Are we asleep?
					pgInSleepRect,		// Is the mouse in the sleep rect?
					pgMustSleep,		// Do we need to fall asleep now?
					pgMustWake,			// Do we need to wake up now?
					pgBouncingClock,	// Should there be a bouncing clock?
					pgBouncingPict,		// Should there be a bouncing picture?
					pgMenubarKluge,		// Should we play with the menu bar?
					pgMustSave,			// Are we turned on?
					pgHasColorQD;		// Do we support Color Quickdraw?
	short			pgSleepRect,		// index number of the sleep rect
					pgWakeRect,			// index number of the wake rect
					pgOldHeight,		// old menu bar height
					pgIntervalTime,		// time between ST maintenance runs
					pgVertical,			// vertical size of picture
					pgHorizontal;		// horizontal size of picture
	long			pgRefreshTime,		// ticks between refreshes
					pgLastAction,		// time of last user action
					pgLastCheck,		// time of last maintenance check
					pgIdleTicks,		// idle ticks before sleep
					pgLastRefresh;		// time of last refresh
	Point			pgLastMouse;		// point where mouse was last seen
	Rect			pgCorners[4],		// corners of the main screen (rects)
					pgClockRect,		// clock frame
					pgPictRect;			// pgPict frame
	Pattern			pgForePat,			// foreground pattern
					pgBackPat;			// background pattern
	PicHandle		pgClockPict,		// clock background picture
					pgPict;				// background picture
} PatchGlobals, *PatchGlobalsPtr;

typedef struct PrefStructure {
	short	version;					// our version number
	char	sleepNowCorner,				// sleep now corner
			sleepNeverCorner,			// sleep never corner
			idleTime;					// idle time (seconds)
	Boolean	bounceClock,				// show the clock?
			bouncePict,					// show a picture?
			saverOn;					// screen saver on?
	char	refreshSeconds;				// refresh time (seconds)
	Boolean	showIcon,					// show the startup icon?
			fadeToWhite,				// fade to white?
			zeroBar,					// zero menubar?
			eraseRectPatch,				// patch flags...
			eraseOvalPatch,
			eraseRgnPatch,
			drawMenuBarPatch,
			initCursorPatch;
} PrefStructure, *PrefStructurePtr, **PrefStructureHandle;
