/**********************************************************
 *	Basic Black  1993,1994 by Mason L. Bliss
 *	All Rights Reserved
 *	version 1.4.1
 *
 *	This cdev code uses the sample cdev class included with
 *	the Think C 5.0.4 compiler. To build the project, you
 *	will have to supply the Symantec code or an equivalent.
 *
 *	The important bits involve the use of the Gestalt manager
 *	for cdev/INIT communication, to which the cdev mechanism
 *	itself is irrelevant.
 **********************************************************/

#include <cdev.h>
#include <Folders.h>
#include <GestaltEqu.h>
#include "BBcdev.h"
#include "BB.h"



/**********************************************************
 *	BBcdev::Init
 *
 *	This method initializes stuff.
 **********************************************************/
void BBcdev::Init(void)
{
	PrefStructureHandle	prefHandle;
	ControlHandle		theControl;
	short				controlValue;
	long				theLong, width, height;
	Rect				box;
	Str255				theString;
	Boolean				usingPrefsFile;
	short				theResFile;

	/* Initialize stuff */
	inherited::Init();
	
	/* Open up the preferences file */
	theResFile = CurResFile();
	usingPrefsFile = OpenPrefsFile();

	/* if usingPrefsFile == false then we're opening our internal prefs */
	prefHandle = (PrefStructureHandle) GetIndResource('PREF', 1);
	if (ResError() == noErr) {
		/* Load & Lock Picture Resources */
		pictHandles[0] = GetResource('PICT', topLeftPict);
		pictHandles[1] = GetResource('PICT', topRightPict);
		pictHandles[2] = GetResource('PICT', botRightPict);
		pictHandles[3] = GetResource('PICT', botLeftPict);
		pictHandles[4] = GetResource('PICT', noArrowPict);
		pictHandles[5] = GetResource('PICT', upArrowPict);
		pictHandles[6] = GetResource('PICT', dnArrowPict);
		pictHandles[7] = GetResource('PICT', grArrowPict);
		pictHandles[8] = GetResource('PICT', grabPictUpPict);
		pictHandles[9] = GetResource('PICT', grabPictDnPict);
		pictHandles[10] = GetResource('PICT', defPictUpPict);
		pictHandles[11] = GetResource('PICT', defPictDnPict);
		HLock(pictHandles[0]);
		HLock(pictHandles[1]);
		HLock(pictHandles[2]);
		HLock(pictHandles[3]);
		HLock(pictHandles[4]);
		HLock(pictHandles[5]);
		HLock(pictHandles[6]);
		HLock(pictHandles[7]);
		HLock(pictHandles[8]);
		HLock(pictHandles[9]);
		HLock(pictHandles[10]);
		HLock(pictHandles[11]);
	
		/* get the sleep corner info */
		sleepNowRect = (**prefHandle).sleepNowCorner;
		GetDItem(dp, lastItem - initDev + sleepNow,
					&controlValue, &theControl, &box);
		SetDItem(dp, lastItem - initDev + sleepNow,
					controlValue, pictHandles[sleepNowRect], &box);
		InsetRect(&box, 3, 3);
		EraseRect(&box);
		InsetRect(&box, -3, -3);
		DrawPicture(pictHandles[sleepNowRect], &box);
		
		width  = ((box.right - box.left) / 2);
		height = ((box.bottom - box.top) / 2);
		
		/* Set up some small rects */
		smallSNRect[0] = box;
		smallSNRect[0].right -= width;
		smallSNRect[0].bottom -= height;
		smallSNRect[1] = box;
		smallSNRect[1].left += width;
		smallSNRect[1].bottom -= height;
		smallSNRect[2] = box;
		smallSNRect[2].left += width;
		smallSNRect[2].top += height;
		smallSNRect[3] = box;
		smallSNRect[3].right -= width;
		smallSNRect[3].top += height;
		
		/* get the wake corner info */
		neverSleepRect = (**prefHandle).sleepNeverCorner;
		GetDItem(dp, lastItem - initDev + neverSleep,
					&controlValue, &theControl, &box);
		SetDItem(dp, lastItem - initDev + neverSleep,
					controlValue, pictHandles[neverSleepRect], &box);
		InsetRect(&box, 3, 3);
		EraseRect(&box);
		InsetRect(&box, -3, -3);
		DrawPicture(pictHandles[neverSleepRect], &box);
	
		width  = ((box.right - box.left) / 2);
		height = ((box.bottom - box.top) / 2);
	
		/* Set up more small rects */
		smallNSRect[0] = box;
		smallNSRect[0].right -= width;
		smallNSRect[0].bottom -= height;
		smallNSRect[1] = box;
		smallNSRect[1].left += width;
		smallNSRect[1].bottom -= height;
		smallNSRect[2] = box;
		smallNSRect[2].left += width;
		smallNSRect[2].top += height;
		smallNSRect[3] = box;
		smallNSRect[3].right -= width;
		smallNSRect[3].top += height;
				
		/* get the clock checkbox */
		GetDItem(dp, lastItem - initDev + clockOn, &controlValue, &theControl, &box);
		if ((**prefHandle).bounceClock)
			SetCtlValue(theControl, 1);
		
		/* get the pict checkbox */
		GetDItem(dp, lastItem - initDev + pictOn, &controlValue, &theControl, &box);
		if ((**prefHandle).bouncePict)
			SetCtlValue(theControl, 1);
		
		/* get the "screen saver on" checkbox */
		GetDItem(dp, lastItem - initDev + screenOn, &controlValue, &theControl, &box);
		if ((**prefHandle).saverOn)
			SetCtlValue(theControl, 1);
		
		/* get the "Show Startup Icon" checkbox */
		GetDItem(dp, lastItem - initDev + startupIcon, &controlValue, &theControl, &box);
		if ((**prefHandle).showIcon)
			SetCtlValue(theControl, 1);
		
		/* get the "Fade To White" checkbox */
		GetDItem(dp, lastItem - initDev + fadeWhite, &controlValue, &theControl, &box);
		if ((**prefHandle).fadeToWhite)
			SetCtlValue(theControl, 1);
	
		/* get the "Zero Menubar" checkbox */
		GetDItem(dp, lastItem - initDev + zeroMenu, &controlValue, &theControl, &box);
		if ((**prefHandle).zeroBar)
			SetCtlValue(theControl, 1);
	
		/* get the "EraseRect" checkbox */
		GetDItem(dp, lastItem - initDev + eraseRect, &controlValue, &theControl, &box);
		if ((**prefHandle).eraseRectPatch)
			SetCtlValue(theControl, 1);
		
		/* get the "EraseOval" checkbox */
		GetDItem(dp, lastItem - initDev + eraseOval, &controlValue, &theControl, &box);
		if ((**prefHandle).eraseOvalPatch)
			SetCtlValue(theControl, 1);
		
		/* get the "EraseRgn" checkbox */
		GetDItem(dp, lastItem - initDev + eraseRgn, &controlValue, &theControl, &box);
		if ((**prefHandle).eraseRgnPatch)
			SetCtlValue(theControl, 1);
		
		/* get the "DrawMenuBar" checkbox */
		GetDItem(dp, lastItem - initDev + drawMenu, &controlValue, &theControl, &box);
		if ((**prefHandle).drawMenuBarPatch)
			SetCtlValue(theControl, 1);
		
		/* get the "InitCursor" checkbox */
		GetDItem(dp, lastItem - initDev + initCurs, &controlValue, &theControl, &box);
		if ((**prefHandle).initCursorPatch)
			SetCtlValue(theControl, 1);
		
		/* get the idle time edit text item */
		GetDItem(dp, lastItem - initDev + idleMins, &controlValue, &theControl, &box);
		theLong = (long) (**prefHandle).idleTime;
		NumToString(theLong, theString);
		SetIText(theControl, theString);
		SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
	
		GetDItem(dp, lastItem - initDev + idleRect, &controlValue, &theControl, &box);
		height = ((box.bottom - box.top) / 2);
		smIdleRect = box;
		smIdleRect.bottom -= height;
		
		/* get the refresh time edit text item */
		GetDItem(dp, lastItem - initDev + refreshSecs, &controlValue, &theControl, &box);
		theLong = (long) (**prefHandle).refreshSeconds;
		NumToString(theLong, theString);
		SetIText(theControl, theString);
	
		GetDItem(dp, lastItem - initDev + refrRect, &controlValue, &theControl, &box);
		height = ((box.bottom - box.top) / 2);
		smRefrRect = box;
		smRefrRect.bottom -= height;
	
		/* see if the idle time and refresh secs arrows need to be grey */
		if (Gestalt('sysv', &theLong) != noErr || theLong < 0x700) {
			GetDItem(dp, lastItem - initDev + idleRect,
							&controlValue, &theControl, &box);
			SetDItem(dp, lastItem - initDev + idleRect,
					controlValue, pictHandles[grArrow], &box);
			GetDItem(dp, lastItem - initDev + refrRect,
							&controlValue, &theControl, &box);
			SetDItem(dp, lastItem - initDev + refrRect,
					controlValue, pictHandles[grArrow], &box);
		}
		ReleaseResource(prefHandle);

		if (usingPrefsFile) {
			CloseResFile(CurResFile());
			UseResFile(theResFile);
		}

	} else {
		Error(cdevResErr);
		return;
	}
}



/**********************************************************
 *	BBcdev::Idle
 *
 *	Fix the EditText items if needed.
 **********************************************************/
void BBcdev::Idle(void)
{
	ControlHandle	theControl;
	short			controlValue;
	long			theLong;
	Rect			box;
	Str255			theString;
	
	if (mustRemember) {
		mustRemember = false;
		/* fix the idle time information if needed */
		GetDItem(dp, lastItem - initDev + idleMins, &controlValue, &theControl, &box);
		GetIText(theControl, theString);
		StringToNum(theString, &theLong);
		if (theLong < 1) {
			SetIText(theControl, "\p1");
			SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
		} else if (theLong > 60) {
			SetIText(theControl, "\p60");
			SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
		}
	
		/* fix the refresh time information if needed */
		GetDItem(dp, lastItem - initDev + refreshSecs, &controlValue, &theControl, &box);
		GetIText(theControl, theString);
		StringToNum(theString, &theLong);
		if (theLong < 1) {
			SetIText(theControl, "\p1");
			SelIText(dp, lastItem - initDev + refreshSecs, 0, 32767);
		} else if (theLong > 20) {
			SetIText(theControl, "\p20");
			SelIText(dp, lastItem - initDev + refreshSecs, 0, 32767);
		}
		RememberValues();
	}
}



/**********************************************************
 *	BBcdev::Close
 *
 *	This method releases the 'PICT' resources.
 **********************************************************/
void BBcdev::Close(void)
{
	short	i;
	
	for (i = 0; i < kNumberOfPictures - 1; ++i) {
		HUnlock(pictHandles[i]);
		ReleaseResource(pictHandles[i]);
	}
	
	inherited::Close();
}



/**********************************************************
 *	BBcdev::Key
 *
 *	This filters out invalid key presses and stuff.
 **********************************************************/
void BBcdev::Key(short theKey)
{
	if (((theKey < '0') || (theKey > '9')) && (theKey != 8)
						&& (theKey != 9) && ((theKey < 28) || (theKey > 31))) {
		event->what = nullEvent;
		return;
	}
	
	/* if we got this far, then we have a reasonably valid keystroke */
	mustRemember = true;
}



/**********************************************************
 *	BBcdev::ItemHit
 *
 *	This handles dialog item hits.
 **********************************************************/
void BBcdev::ItemHit(short theItem)
{
	switch (theItem) {
		case sleepNow:
			if (HitSleepNow(theItem))
				RememberValues();
			break;
			
		case neverSleep:
			if (HitNeverSleep(theItem))
				RememberValues();
			break;

		case idleRect:
			if (HitIdleRect(theItem))
				RememberValues();
			break;

		case refrRect:
			if (HitRefreshRect(theItem))
				RememberValues();
			break;

		case clockOn:
			HitClock(theItem);
			RememberValues();
			break;

		case pictOn:	/* Hey! Leave me alone! */
			HitPict(theItem);
			RememberValues();
			break;

		case defaultPict:
			if (HitDefaultPict(theItem))
				RememberValues();
			break;
			
		case grabPict:
			if (HitGrabPict(theItem))
				RememberValues();
			break;
			
		case screenOn:
		case startupIcon:
		case fadeWhite:
		case zeroMenu:
		case eraseRect:
		case eraseOval:
		case eraseRgn:
		case drawMenu:
		case initCurs:
			HitCheckBox(theItem);
			RememberValues();
			break;

		default:
			break;
	}
}



/**********************************************************
 *	BBcdev::HitSleepNow
 *
 *	The sleep now item was hit.
 **********************************************************/
Boolean BBcdev::HitSleepNow(short theItem)
{
	Boolean			drawOtherAsWell = false;
	short			controlValue, initialRect;
	Rect			box;
	ControlHandle	theControl;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	initialRect = sleepNowRect;
	GlobalToLocal(&event->where);
	if (PtInRect(event->where, &smallSNRect[topLeftRect])) {
		if (neverSleepRect == topLeftRect) {
			neverSleepRect = sleepNowRect;
			drawOtherAsWell = true;
		}
		sleepNowRect = topLeftRect;
	} else if (PtInRect(event->where, &smallSNRect[topRightRect])) {
		if (neverSleepRect == topRightRect) {
			neverSleepRect = sleepNowRect;
			drawOtherAsWell = true;
		}
		sleepNowRect = topRightRect;
	} else if (PtInRect(event->where, &smallSNRect[botRightRect])) {
		if (neverSleepRect == botRightRect) {
			neverSleepRect = sleepNowRect;
			drawOtherAsWell = true;
		}
		sleepNowRect = botRightRect;
	} else if (PtInRect(event->where, &smallSNRect[botLeftRect])) {
		if (neverSleepRect == botLeftRect) {
			neverSleepRect = sleepNowRect;
			drawOtherAsWell = true;
		}
		sleepNowRect = botLeftRect;
	} else { /* This can't happen. */
		SysBeep(5);
		return false;
	}
	
	if (initialRect == sleepNowRect)	/* Nothing changed */
		return false;
	
	/* Draw the new picture */
	SetDItem(dp, lastItem - initDev + sleepNow,
			controlValue, pictHandles[sleepNowRect], &box);
	InsetRect(&box, 3, 3);
	EraseRect(&box);
	InsetRect(&box, -3, -3);
	DrawPicture(pictHandles[sleepNowRect], &box);
	
	if (drawOtherAsWell) {
		GetDItem(dp, lastItem - initDev + neverSleep, &controlValue, &theControl, &box);
		SetDItem(dp, lastItem - initDev + neverSleep, controlValue,
				pictHandles[neverSleepRect], &box);
		InsetRect(&box, 3, 3);
		EraseRect(&box);
		InsetRect(&box, -3, -3);
		DrawPicture(pictHandles[neverSleepRect], &box);
	}
	
	return true;
}



/**********************************************************
 *	BBcdev::HitNeverSleep
 *
 *	The never sleep item was hit.
 **********************************************************/
Boolean BBcdev::HitNeverSleep(short theItem)
{
	Boolean			drawOtherAsWell = false;
	short			controlValue, initialRect;
	Rect			box;
	ControlHandle	theControl;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	initialRect = neverSleepRect;
	GlobalToLocal(&event->where);
	if (PtInRect(event->where, &smallNSRect[topLeftRect])) {
		if (sleepNowRect == topLeftRect) {
			sleepNowRect = neverSleepRect;
			drawOtherAsWell = true;
		}
		neverSleepRect = topLeftRect;
	} else if (PtInRect(event->where, &smallNSRect[topRightRect])) {
		if (sleepNowRect == topRightRect) {
			sleepNowRect = neverSleepRect;
			drawOtherAsWell = true;
		}
		neverSleepRect = topRightRect;
	} else if (PtInRect(event->where, &smallNSRect[botRightRect])) {
		if (sleepNowRect == botRightRect) {
			sleepNowRect = neverSleepRect;
			drawOtherAsWell = true;
		}
		neverSleepRect = botRightRect;
	} else if (PtInRect(event->where, &smallNSRect[botLeftRect])) {
		if (sleepNowRect == botLeftRect) {
			sleepNowRect = neverSleepRect;
			drawOtherAsWell = true;
		}
		neverSleepRect = botLeftRect;
	} else {	/* This can't happen. */
		SysBeep(5);
		return false;
	}
	
	if (initialRect == neverSleepRect)	/* Nothing changed */
		return false;

	/* Draw the new picture */
	SetDItem(dp, lastItem - initDev + neverSleep,
			controlValue, pictHandles[neverSleepRect], &box);
	InsetRect(&box, 3, 3);
	EraseRect(&box);
	InsetRect(&box, -3, -3);
	DrawPicture(pictHandles[neverSleepRect], &box);

	if (drawOtherAsWell) {
		GetDItem(dp, lastItem - initDev + sleepNow, &controlValue, &theControl, &box);
		SetDItem(dp, lastItem - initDev + sleepNow, controlValue,
				pictHandles[sleepNowRect], &box);
		InsetRect(&box, 3, 3);
		EraseRect(&box);
		InsetRect(&box, -3, -3);
		DrawPicture(pictHandles[sleepNowRect], &box);
	}
	
	return true;
}



/**********************************************************
 *	BBcdev::HitIdleRect
 *
 *	The idle item was hit.
 **********************************************************/
Boolean BBcdev::HitIdleRect(short theItem)
{
	long			theLong, theTime = 0;
	short			controlValue;
	Rect			box, save;
	ControlHandle	theControl;
	Str255			theString;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	if (Gestalt('sysv', &theLong) != noErr && theLong < 0x700)
		return false;
	save = box;
	GlobalToLocal(&event->where);
	GetDItem(dp, lastItem - initDev + idleMins,
					&controlValue, &theControl, &box);
	GetIText(theControl, theString);
	StringToNum(theString, &theLong);
	theTime = Ticks - 16;
	if (PtInRect(event->where, &smIdleRect)) {			// higher!!!
		DrawPicture(pictHandles[upArrow], &save);
		SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
		do {
			SystemTask();
			if (Ticks - theTime > 15) {
				theTime = Ticks;
				if (theLong < 10) {
					NumToString(theLong += 1, theString);
					SetIText(theControl, theString);
					if (theLong == 10)
						SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
				} else if (theLong < 60) {
					NumToString((theLong += 5) > 60 ? (theLong = 60) : theLong, theString);
					SetIText(theControl, theString);
				}
			}
		} while (Button());
	} else {											// lower.
		DrawPicture(pictHandles[dnArrow], &save);
		SelIText(dp, lastItem - initDev + idleMins, 0, 32767);
		do {
			SystemTask();
			if (Ticks - theTime > 15) {
				theTime = Ticks;
				if (theLong > 10) {
					NumToString(theLong -= 5, theString);
					SetIText(theControl, theString);
				} else if (theLong > 1) {
						NumToString(theLong -= 1, theString);
						SetIText(theControl, theString);
				}
			}
		} while (Button());
	}
	box = save;
	box.left += 3;
	box.right -= 3;
	box.top += 3;
	box.bottom -= 3;
	EraseRect(&box);
	DrawPicture(pictHandles[noArrow], &save);
	
	return true;
}



/**********************************************************
 *	BBcdev::HitRefreshRect
 *
 *	The refresh item was hit.
 **********************************************************/
Boolean BBcdev::HitRefreshRect(short theItem)
{
	long			theLong, theTime = 0;
	short			controlValue;
	Rect			box, save;
	ControlHandle	theControl;
	Str255			theString;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	if (Gestalt('sysv', &theLong) != noErr && theLong < 0x700)
		return false;
	save = box;
	GlobalToLocal(&event->where);
	GetDItem(dp, lastItem - initDev + refreshSecs,
					&controlValue, &theControl, &box);
	GetIText(theControl, theString);
	StringToNum(theString, &theLong);
	theTime = Ticks - 16;
	if (PtInRect(event->where, &smRefrRect)) {			// higher!!!
		DrawPicture(pictHandles[upArrow], &save);
		SelIText(dp, lastItem - initDev + refreshSecs, 0, 32767);
		do {
			SystemTask();
			if (Ticks - theTime > 15) {
				theTime = Ticks;
				if (theLong < 20) {
					NumToString(theLong += 1, theString);
					SetIText(theControl, theString);
					if (theLong == 10)
						SelIText(dp, lastItem - initDev + refreshSecs, 0, 32767);
				}					}
		} while (Button());
	} else {											// lower.
		DrawPicture(pictHandles[dnArrow], &save);
		SelIText(dp, lastItem - initDev + refreshSecs, 0, 32767);
		do {
			SystemTask();
			if (Ticks - theTime > 15) {
				theTime = Ticks;
				if (theLong > 1) {
					NumToString(theLong -= 1, theString);
					SetIText(theControl, theString);
				}
			}
		} while (Button());
	}
	box = save;
	box.left += 3;
	box.right -= 3;
	box.top += 3;
	box.bottom -= 3;
	EraseRect(&box);
	DrawPicture(pictHandles[noArrow], &save);
	
	return true;
}



/**********************************************************
 *	BBcdev::HitClock
 *
 *	The clock item was hit.
 **********************************************************/
void BBcdev::HitClock(short theItem)
{
	short			controlValue, otherControlValue;
	Rect			box;
	ControlHandle	theControl, theOtherControl;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);
	GetDItem(dp, lastItem - initDev + pictOn, &otherControlValue, &theOtherControl, &box);
	
	controlValue = GetCtlValue(theControl);
	otherControlValue = GetCtlValue(theOtherControl);
	controlValue = !controlValue;
	SetCtlValue(theControl, controlValue);
	if (controlValue & otherControlValue) {
		SetCtlValue(theOtherControl, !otherControlValue);
	}
}



/**********************************************************
 *	BBcdev::HitPict
 *
 *	The pict item was hit.
 **********************************************************/
void BBcdev::HitPict(short theItem)
{
	short			controlValue, otherControlValue;
	Rect			box;
	ControlHandle	theControl, theOtherControl;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);
	GetDItem(dp, lastItem - initDev + clockOn, &otherControlValue, &theOtherControl, &box);
	
	controlValue = GetCtlValue(theControl);
	otherControlValue = GetCtlValue(theOtherControl);
	controlValue = !controlValue;
	SetCtlValue(theControl, controlValue);
	if (controlValue & otherControlValue) {
		SetCtlValue(theOtherControl, !otherControlValue);
	}
}



/**********************************************************
 *	BBcdev::HitDefaultPict
 *
 *	The "default picture" item was hit.
 **********************************************************/
Boolean BBcdev::HitDefaultPict(short theItem)
{
	PatchGlobalsPtr	pgPtr;
	Boolean			inThePicture = true, usingPrefsFile;
	short			resAttrs, theResFile, thePrefsFile, controlValue;
	Rect			box;
	Point			theLoc;
	ControlHandle	theControl;
	Handle			theResource, thePicture;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	DrawPicture(pictHandles[11], &box);
	while (StillDown()) {
		SystemTask();
		GetMouse(&theLoc);
		if (!PtInRect(theLoc, &box) && inThePicture == true) {
			DrawPicture(pictHandles[10], &box);
			inThePicture = false;
		} else if (PtInRect(theLoc, &box) && inThePicture == false) {
			DrawPicture(pictHandles[11], &box);
			inThePicture = true;
		}
	}
	DrawPicture(pictHandles[10], &box);

	if (inThePicture) {		/* Do we want to do this? */
		/* Open up the preferences file */
		theResFile = CurResFile();
		usingPrefsFile = OpenPrefsFile();
		thePrefsFile = CurResFile();
	
		if (usingPrefsFile) {
			/* Get the default picture */
			UseResFile(theResFile);
			theResource = GetResource('PICT', 256);
			resAttrs = GetResAttrs(theResource);
			DetachResource(theResource);
			
			/* Remove the current picture */
			UseResFile(thePrefsFile);
			thePicture = GetResource('PICT', 256);
			RmveResource(thePicture);
			DisposHandle(thePicture);	/* see IM:I, p.124 */
			
			/* Slap in the default picture */
			AddResource(theResource, 'PICT', 256, "\pBouncing Picture");
			SetResAttrs(theResource, resAttrs);
			ChangedResource(theResource);
			WriteResource(theResource);
			DetachResource(theResource);

			CloseResFile(CurResFile());
			UseResFile(theResFile);
		}

		/* Save the picture in memory */
		if (Gestalt('BBlk', (long *) &pgPtr) == noErr) {
			EmptyHandle(pgPtr->pgPict);
			pgPtr->pgPict = (PicHandle) theResource;
			pgPtr->pgPictRect = (**(PicHandle) theResource).picFrame;
			if (pgPtr->pgBouncingPict) {
				pgPtr->pgHorizontal = (pgPtr->pgPictRect).right - (pgPtr->pgPictRect).left;
				pgPtr->pgVertical = (pgPtr->pgPictRect).bottom - (pgPtr->pgPictRect).top;
			}
		}
		
		/* Toggle the appropriate checkboxes */
		GetDItem(dp, lastItem - initDev + clockOn, &controlValue, &theControl, &box);
		controlValue = GetCtlValue(theControl);
		if (controlValue) {
			SetCtlValue(theControl, !controlValue);
		}
		GetDItem(dp, lastItem - initDev + pictOn, &controlValue, &theControl, &box);
		controlValue = GetCtlValue(theControl);
		if (!controlValue) {
			SetCtlValue(theControl, !controlValue);
		}
		return true;
	} else return false;
}



/**********************************************************
 *	BBcdev::GrabPict
 *
 *	The "grab picture" item was hit.
 **********************************************************/
Boolean BBcdev::HitGrabPict(short theItem)
{
	PatchGlobalsPtr	pgPtr;
	Boolean			inThePicture = true, usingPrefsFile;
	short			resAttrs, theResFile, controlValue;
	Rect			box;
	long			theLong, theResult;
	Point			theLoc;
	ControlHandle	theControl;
	Handle			theResource, thePicture;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);

	DrawPicture(pictHandles[9], &box);
	while (StillDown()) {
		SystemTask();
		GetMouse(&theLoc);
		if (!PtInRect(theLoc, &box) && inThePicture == true) {
			DrawPicture(pictHandles[8], &box);
			inThePicture = false;
		} else if (PtInRect(theLoc, &box) && inThePicture == false) {
			DrawPicture(pictHandles[9], &box);
			inThePicture = true;
		}
	}
	DrawPicture(pictHandles[8], &box);
	
	/* Paste the picture, if it's there, we really want it, and we can get it */
	if (inThePicture && (LoadScrap() == noErr)) {

		/* Make sure the picture is in the system heap */
		thePicture = NewHandleSys(0);

		if ((theResult = GetScrap(thePicture, 'PICT', &theLong)) >= 0) {
		
			/* thePicture should now be a valid handle to a picture */

			/* Save the picture in memory */
			if (Gestalt('BBlk', (long *) &pgPtr) == noErr) {

				/* Get rid of the old picture, and clear room for the new */
				DisposHandle(pgPtr->pgPict);
				if ((pgPtr->pgPict = (PicHandle) NewHandleSys(theResult)) != nil) {

					/* Lock up for safety */
					HLock(thePicture);
					HLock(pgPtr->pgPict);

					/* Copy the picture */
					BlockMove(*thePicture,*(pgPtr->pgPict),theResult);
					
					/* Unlock */
					HUnlock(pgPtr->pgPict);
					HUnlock(thePicture);

					/* Record the picture size */
					pgPtr->pgPictRect = (**(PicHandle) pgPtr->pgPict).picFrame;
					if (pgPtr->pgBouncingPict) {
						pgPtr->pgHorizontal = (pgPtr->pgPictRect).right - (pgPtr->pgPictRect).left;
						pgPtr->pgVertical = (pgPtr->pgPictRect).bottom - (pgPtr->pgPictRect).top;
					}
				} else {
					
					/* We couldn't allocate the picture handle, for whatever reason - bail,
						but first set the checkboxes so that the user knows they don't have
						a picture. Beep for good measure. */

					GetDItem(dp, lastItem - initDev + clockOn, &controlValue, &theControl, &box);
					controlValue = GetCtlValue(theControl);
					if (!controlValue) {
						SetCtlValue(theControl, !controlValue);
					}
					GetDItem(dp, lastItem - initDev + pictOn, &controlValue, &theControl, &box);
					controlValue = GetCtlValue(theControl);
					if (controlValue) {
						SetCtlValue(theControl, !controlValue);
					}
					
					SysBeep(5);
					return false;
				}
			}

			/* Write the picture to our preferences file */
			/* Open up the preferences file */
			theResFile = CurResFile();
			usingPrefsFile = OpenPrefsFile();

			if (usingPrefsFile) {

				/* Remove the current picture */
				theResource = GetResource('PICT', 256);
				resAttrs = GetResAttrs(theResource);
				RmveResource(theResource);
				DisposHandle(theResource);	/* see IM:I, p.124 */

				/* Slap in the new picture */
				AddResource(pgPtr->pgPict, 'PICT', 256, "\pBouncing Picture");
				SetResAttrs(pgPtr->pgPict, resAttrs);
				ChangedResource(pgPtr->pgPict);
				WriteResource(pgPtr->pgPict);
				DetachResource(pgPtr->pgPict);

				CloseResFile(CurResFile());
				UseResFile(theResFile);
			}

			/* Toggle the appropriate checkboxes */
			GetDItem(dp, lastItem - initDev + clockOn, &controlValue, &theControl, &box);
			controlValue = GetCtlValue(theControl);
			if (controlValue) {
				SetCtlValue(theControl, !controlValue);
			}
			GetDItem(dp, lastItem - initDev + pictOn, &controlValue, &theControl, &box);
			controlValue = GetCtlValue(theControl);
			if (!controlValue) {
				SetCtlValue(theControl, !controlValue);
			}
			return true;
		}
	}

	return false;
}



/**********************************************************
 *	BBcdev::ToggleBox
 *
 *	A checkbox was hit.
 **********************************************************/
void BBcdev::HitCheckBox(short theItem)
{
	short			controlValue;
	Rect			box;
	ControlHandle	theControl;

	GetDItem(dp, lastItem - initDev + theItem, &controlValue, &theControl, &box);
	
	controlValue = GetCtlValue(theControl);
	controlValue = !controlValue;
	SetCtlValue(theControl, controlValue);
}



/**********************************************************
 *	BBcdev::RememberValues
 *
 *	This saves the information in the CNFG resource, and,
 *	if the Basic Black INIT is loaded, sets the values of
 *	its patch globals in memory.
 **********************************************************/
void BBcdev::RememberValues(void)
{
	PatchGlobalsPtr		pgPtr;
	PrefStructureHandle	prefHandle;
	ControlHandle		theControl;
	short				controlValue, theResFile;
	long				theLong;
	Rect				box;
	Str255				theString;
	Boolean				usingPrefsFile;

	/* Open up the preferences file */
	theResFile = CurResFile();
	usingPrefsFile = OpenPrefsFile();

	/* if usingPrefsFile == false then we're opening our internal prefs */
	prefHandle = (PrefStructureHandle) GetIndResource('PREF', 1);
	if (ResError() == noErr && (**prefHandle).version == kVersion) {
	
		/* save the idle time information */
		GetDItem(dp, lastItem - initDev + idleMins, &controlValue, &theControl, &box);
		GetIText(theControl, theString);
		StringToNum(theString, &theLong);
		(**prefHandle).idleTime = (short) theLong;
	
		/* save the refresh time information */
		GetDItem(dp, lastItem - initDev + refreshSecs, &controlValue, &theControl, &box);
		GetIText(theControl, theString);
		StringToNum(theString, &theLong);
		(**prefHandle).refreshSeconds = (short) theLong;
	
		/* save the sleep corner information */
		(**prefHandle).sleepNowCorner = sleepNowRect;
		
		/* save the wake corner information */
		(**prefHandle).sleepNeverCorner = neverSleepRect;
	
		/* save the clock information */
		GetDItem(dp, lastItem - initDev + clockOn, &controlValue, &theControl, &box);
		(**prefHandle).bounceClock = GetCtlValue(theControl);
	
		/* save the pict information */
		GetDItem(dp, lastItem - initDev + pictOn, &controlValue, &theControl, &box);
		(**prefHandle).bouncePict = GetCtlValue(theControl);
	
		/* save the "screen saver on" information */
		GetDItem(dp, lastItem - initDev + screenOn, &controlValue, &theControl, &box);
		(**prefHandle).saverOn = GetCtlValue(theControl);
	
		/* save the "Startup Icon" information */
		GetDItem(dp, lastItem - initDev + startupIcon, &controlValue, &theControl, &box);
		(**prefHandle).showIcon = GetCtlValue(theControl);
	
		/* save the "Fade To White" information */
		GetDItem(dp, lastItem - initDev + fadeWhite, &controlValue, &theControl, &box);
		(**prefHandle).fadeToWhite = GetCtlValue(theControl);
	
		/* save the "Zero Menu Bar" information */
		GetDItem(dp, lastItem - initDev + zeroMenu, &controlValue, &theControl, &box);
		(**prefHandle).zeroBar = GetCtlValue(theControl);
	
		/* save the "EraseRect" information */
		GetDItem(dp, lastItem - initDev + eraseRect, &controlValue, &theControl, &box);
		(**prefHandle).eraseRectPatch = GetCtlValue(theControl);
	
		/* save the "EraseOval" information */
		GetDItem(dp, lastItem - initDev + eraseOval, &controlValue, &theControl, &box);
		(**prefHandle).eraseOvalPatch = GetCtlValue(theControl);
	
		/* save the "EraseRgn" information */
		GetDItem(dp, lastItem - initDev + eraseRgn, &controlValue, &theControl, &box);
		(**prefHandle).eraseRgnPatch = GetCtlValue(theControl);
	
		/* save the "DrawMenuBar" information */
		GetDItem(dp, lastItem - initDev + drawMenu, &controlValue, &theControl, &box);
		(**prefHandle).drawMenuBarPatch = GetCtlValue(theControl);
	
		/* save the "InitCursor" information */
		GetDItem(dp, lastItem - initDev + initCurs, &controlValue, &theControl, &box);
		(**prefHandle).initCursorPatch = GetCtlValue(theControl);
	
		/* If the extension's installed, then update its patch globals */
		if (Gestalt('BBlk', (long *) &pgPtr) == noErr) {
			if (pgPtr->pgVersion == kVersion) {
				pgPtr->pgMustSleep = false;
				pgPtr->pgSleepRect = (**prefHandle).sleepNowCorner;
				pgPtr->pgWakeRect = (**prefHandle).sleepNeverCorner;
				pgPtr->pgIdleTicks = (long) (**prefHandle).idleTime * 3600;
				pgPtr->pgBouncingClock = (**prefHandle).bounceClock;
				pgPtr->pgBouncingPict = (**prefHandle).bouncePict;
				if (pgPtr->pgBouncingClock) {
					pgPtr->pgHorizontal = (pgPtr->pgClockRect).right - (pgPtr->pgClockRect).left;
					pgPtr->pgVertical = (pgPtr->pgClockRect).bottom - (pgPtr->pgClockRect).top;
				} else {
					pgPtr->pgHorizontal = (pgPtr->pgPictRect).right - (pgPtr->pgPictRect).left;
					pgPtr->pgVertical = (pgPtr->pgPictRect).bottom - (pgPtr->pgPictRect).top;
				}
				pgPtr->pgMenubarKluge = (**prefHandle).zeroBar;
				pgPtr->pgMustSave = (**prefHandle).saverOn;
				pgPtr->pgRefreshTime = (**prefHandle).refreshSeconds * 60;
				if ((**prefHandle).fadeToWhite) {				// Fade to white
					StuffHex(&(pgPtr->pgForePat), "\pFFFFFFFFFFFFFFFF");
					StuffHex(&(pgPtr->pgBackPat), "\p0000000000000000");
				} else {										// Fade to black
					StuffHex(&(pgPtr->pgForePat), "\p0000000000000000");
					StuffHex(&(pgPtr->pgBackPat), "\pFFFFFFFFFFFFFFFF");
				}
			}
		}
	
		ChangedResource(prefHandle);
		WriteResource(prefHandle);
		ReleaseResource(prefHandle);

		if (usingPrefsFile) {
			CloseResFile(CurResFile());
			UseResFile(theResFile);
		}
	}
}



/*********************************************************************
 * OpenPrefsFile:
 *
 * Open up our prefs file. If there are problems, then create a new
 * prefs file. (Also in ScreenDaemon Control.c)
 *
 *********************************************************************/
Boolean OpenPrefsFile()
{
	long	result, directoryID;
	FInfo	fileInfo;
	short	VRefNum, theResFile, thePrefsFile, resAttrs;
	Boolean	prefsFileOpen = false;
	Handle	prefHandle, pictHandle, tmplHandle;
	OSErr	theError;
	Str255	theString;

	theResFile = CurResFile();
	/* Read in our prefs, and do a sick amount of error checking (bleah!) */
	if (Gestalt(gestaltFindFolderAttr, &result) == noErr) {
 		if (result & Bit(gestaltFindFolderPresent)) {
			if (FindFolder(kOnSystemDisk, kPreferencesFolderType, kCreateFolder,
					&VRefNum, &directoryID) == noErr) {
				if ((thePrefsFile = HOpenResFile(VRefNum, directoryID,
								"\pBasic Black Prefs", fsCurPerm)) != -1) {
					/* Cool. We opened the file! Twiddle our watch variable... */
					prefsFileOpen = true;
					
				} else {	/* No go. Try to create a new prefs file. */
				
					HCreateResFile(VRefNum, directoryID, "\pBasic Black Prefs");
					HGetFInfo(VRefNum, directoryID, "\pBasic Black Prefs", &fileInfo);
					fileInfo.fdType = 'pref';
					fileInfo.fdCreator = 'BBlk';
					HSetFInfo(VRefNum, directoryID, "\pBasic Black Prefs", &fileInfo);
					if ((thePrefsFile = HOpenResFile(VRefNum, directoryID,
									"\pBasic Black Prefs", fsCurPerm)) != -1) {
						/* We opened up the new file okay. */
						prefsFileOpen = true;
						
						/* Get preferences resource */
						UseResFile(theResFile);
						prefHandle = GetIndResource('PREF', 1);
						resAttrs = GetResAttrs(prefHandle);
						DetachResource(prefHandle);
						
						/* Write preferences resource */
						UseResFile(thePrefsFile);
						AddResource(prefHandle, 'PREF', 128, "\pPrefs");
						SetResAttrs(prefHandle, resAttrs);
						ChangedResource(prefHandle);
						WriteResource(prefHandle);
						ReleaseResource(prefHandle);

						/* Get picture resource */
						UseResFile(theResFile);
						pictHandle = GetResource('PICT', 256);
						resAttrs = GetResAttrs(pictHandle);
						DetachResource(pictHandle);
						
						/* Write picture resource */
						UseResFile(thePrefsFile);
						AddResource(pictHandle, 'PICT', 256, "\pBouncing Picture");
						SetResAttrs(pictHandle, resAttrs);
						ChangedResource(pictHandle);
						WriteResource(pictHandle);
						ReleaseResource(pictHandle);

						/* Get template resource */
						UseResFile(theResFile);
						tmplHandle = GetIndResource('TMPL', 1);
						resAttrs = GetResAttrs(tmplHandle);
						DetachResource(tmplHandle);
						
						/* Write template resource */
						UseResFile(thePrefsFile);
						AddResource(tmplHandle, 'TMPL', 128, "\pPREF");
						SetResAttrs(tmplHandle, resAttrs);
						ChangedResource(tmplHandle);
						WriteResource(tmplHandle);
						ReleaseResource(tmplHandle);
					}
				}
			}
		}
	}
	
	return prefsFileOpen;
}
