/****** BMTPrefsFile.h ********/
/*
 
 This file could be the basis for a new object, but so far I don't see
 any need to extend the functionality of the BPrefsFile object. Consequently
 this only defines ModemTalk's settings number constants.
 
*/

#define _H_BMTPrefsFile

#include "BPrefsFile.h"

enum MTSettings { sStartup=1, sOpen, sSpeaker, sTone, sBPS, sPhNum, 
		sModemType, sInitStr, sCardNum, sPort, sDoCCard, sPause,
		sPrefsVers, sReminderCkBox, sReminderTime, sLastPref };

#define kMTMaxPref 64
#define kMTNumPrefs (sLastPref-1)

class BMTPrefsFile : public BPrefsFile		{

public:

// Creation & disposal

	OSErr 	IPrefsFile(OSType fileType, OSType sign,
			short strsID, ResType resTyp, short resID);
			
	void	Dispose(void);

// GetSelectedSpeed - return speed chosen by user (value to pass to SerReset())

	short	GetSelectedSpeed(void);
	
// GetBitsPerSecond - return speed in bps (long)

	long 	GetBitsPerSecond(void);

// GetPortNames - return the port chosen by user (".AIn") as Pascal string
	
	void	GetPortNames(char *inPort, char *outPort);
	
// GetDialOnOpen - return whether to dial on Open (Boolean) 
	
	Boolean	GetDialOnOpen(void);
	
// GetDialOnStartup - reeturn whether to dial on system startup (Boolean)
	
	Boolean	GetDialOnStartup(void);
	
// GetDialScript - returns the script to be used to dial. Script will be read 
//	from Prefs file (if present) or from the adev file itself.

	Handle	GetDialScript(void);
	
// GetDialString - return the requested phone number, with "ATMxDx###,,,### [;]<cr>"
//	Tack on a ";" to the string if there's going to be a calling card number

	void	GetDialString(char *theString);
	
// GetCCString - return the calling card number as: ATDTccccccccccc<cr>"

	void	GetCCString(char *theString);
	
// GetModemString - return the selected modem initialization string
	
	void	GetModemString(char *theString);
	
// MacNotCompatible - return TRUE if the Mac won't run ModemTalk

	Boolean MacNotCompatible(void);
};