/******************************* BMTalkDLOG.h *********************************/ 
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	24 March 1993 

 Interface file to the BMTalkDLOG.c object.
  
*/

#define _H_BMTalkDLOG
#include "BPrefsFile.h"

class BMTalkDLOG : indirect	{

	DialogPtr	dMainPtr;	// the main user interface DLOG
	DialogPtr	dMorePtr;	// the "More..." dialog
	short		errSTRNum;	// STR# resource of error messages
	BMTPrefsFile	*itsPrefs;	// prefs file object
	Boolean		isShowing;	// True if we've ever done ShowWindow
	Handle		CDEFrsrc;	// handle to PLM's Popup CDEF, if used
	char		theVers[20];	// our version string
	Cursor 		wCursor;	// the watch cursor

public:

// InitDLOG - Initialize the User Interface using the prefs file's settings.

	OSErr	InitMTalkDLOG(BMTPrefsFile *prefs);	
	
// ShowMTDLOG - show the dialog, with an initial message. If showDial is true,
//		the default button should read "Dial", else it should be "Hangup"

	void	ShowMTDLOG(Boolean showDial, char *initMsg);
	
// DoMTDLOG - Display the user interface and handle any clicks. Return noErr if
//	they clicked OK; return 1 if they clicked Cancel; or OSErr otherwise.
//	If they clicked Connect, saves the settings in the prefs file.

	OSErr	DoMTDLOG(void);			

// ClearDisplay & AddToDisplay - clear or append a string to the screen display

	void	ClearDisplay(void);		// clear the display area
	void	AddToDisplay(char *aStr);	// add this string to the screen

// AddToDebug - append a string to the existing debug trace

	void	AddToDebug(char *aStr);		// add this to the debug string
	
// SetWatchCursor - set the cursor to a watch

	void	SetWatchCursor(void);

// Dispose - deallocate buffers, etc.

	void	Dispose(void);
	
private:	

// SetupMainDLOG & GetSettingsFromMain - move settings to/from DLOG items

	void	SetupMainDLOG(Boolean showDial);
	void	GetSettingsFromMain(void);
	OSErr	SetupMoreDLOG(void);
	OSErr	DoMoreDLOG(void);
	void	GetMoreSettings(void);
	
// Setxxx - Sets the specified item to theSetting
	
	void	SetCheckBox	(DialogPtr dPtr, short dItem, short theSetting);
	void	SetPopup	(DialogPtr dPtr, short dItem, short theSetting);
	void	SetRadioButtons	(DialogPtr dPtr, short bFirst, short bLast, short theSetting);
	void	SetEditText	(DialogPtr dPtr, short dItem, short theSetting);

// Getxxx - Gets the (new) setting from the specified DLOG item
	
	void	GetCheckBox	(DialogPtr dPtr, short dItem, short theSetting);
	void	GetPopup	(DialogPtr dPtr, short dItem, short theSetting);
	void	GetRadioButtons	(DialogPtr dPtr, short bFirst, short bLast, short theSetting);
	void	GetEditText	(DialogPtr dPtr, short dItem, short theSetting);

// DoAlert - display an alert, with specific text, and return clicked item

	short DoAlert (short alertType, short numButtons, 
 			short strNum1, short strNum2, char *extraStr);

// MatchingMenuItem - return the item # from the menu which matches the str

	short MatchingMenuItem (char *str, ControlHandle theCtl);
	
// GetPopupItemText - returns the text of the i'th item from a popup menu
	
	void GetPopupItemText(ControlHandle theCtl, short itemNo, char *str);				

};

#pragma mark _defines

/* DLOG constants */
#define  	MAINDLOG	256			/* id of the main dialog */
#define		ONEBUTTON	258			/* one button dialog */
#define 	TWOBUTTON	259			/* two button dialog */

	/* ALRT constants */
#define		SMALLONE	260			/* small, one button ALRT */
#define		SMALLTWO	261
#define		BIGONE		262
#define		BIGTWO		263

#define		AatKID		128			/* id of AatK resource */

#define		errStrID	258			/* STR# for errors */

enum alertKinds {Astop, Anote, Acaution};