/******************************* BMTalkDialer.h *******************************/ 
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	8 April 1993 

 Defines for a Dialer object.
 
*/

#define _H_BMTalkDialer

#include "BMTPrefsFile.h"
#include "BMTalkDLOG.h"
enum eDialerErrors { 
	dialerAborted	= -1,
	dialerBadCmd	= -2,
	dialerPastEOF	= -3
	};

class 	BMTalkDialer : indirect		{

public:
// Creation and Disposal...

	OSErr 	IBMTalkDialer(BMTPrefsFile *thePrefsFile, BMTalkDLOG *theDisplay);
	void	Dispose(void);
	
// Dialing
	OSErr	Dial(void);

// Hanging up
	OSErr	Hangup(void);
	
private:
	OSErr 	DDInit(void);
	OSErr	DDRun(void);
	short 	DDFetch (void);
	short 	DDExecute (Boolean * dontStop);
	
	short 	DoSend(Boolean * stop);
	short 	DoReceive(Boolean * stop);
	short 	DoDial(Boolean * stop);
	short 	DoBreak(Boolean * stop);
	short 	DoGoto(Boolean * stop);
	short 	DoIf(Boolean * stop);
	short 	DoCount(Boolean * stop);
	short 	DoLoop(Boolean * stop);
	short 	DoDisplay(Boolean * stop);
	short 	DoStop(Boolean * stop);
	short 	DoDebug(Boolean * stop);
	short 	DoWait(Boolean * stop);
	short 	DoRem(Boolean * stop);
	short 	DoInitStr(Boolean * stop);
	short 	DoFlush(Boolean * stop);

	short	MatchKey(short * nextChar);
	void	StripComment(short * nextChar);
	void	ParseTokens(short numArgs, short nextChar);
	short	atoh(char * theChar);
	void	RemoveDollars(char * theTok);
	void 	makelc(char * theStr);
	void 	StripBlanks(char * theStr);
	void 	ClearModemInput(void);
	void 	UpdatePC(char * theAddr);
 	short 	DoAlert(short alertType, short numButtons, short str1, short str2, char *extraStr);

// Instance variables

	short	dialPC;			/* current PC (string number) */
	short	lastPC;			/* previous PC */
	short	loopPC;			/* PC of the opening COUNT instr */
	short	counter;		/* index variable of the Count/Loop */
	short	pgmLen;			/* number of STR's in the STR# */
	Ptr	pgmPtr;			/* ptr to start of the pgm's STR# + 2 */
	Ptr	pgmPCPtr;		/* pointer to current instruction */
	Handle 	itsScript;		/* handle to script STR# */
	Handle	itsErrors;		/* handle to Error msg STR# */
	BMTalkDLOG	*itsDisplay; 	/* the user interface */
	BMTPrefsFile	*itsPrefs;	/* the preferences file */
	
	Boolean	debugMode;
	
	/* the next four variables are PZstrings: lengthByte + data + nul */
	 
	char	statement[258];		/* the current statement */
	char	token[2][130];		/* up to two tokens from the instruction */
	char	modemInput[130];	/* what we received from the modem */
	char	matchString[130];	/* the stuff we matched */
};