/******************************* LAPMgrGlue.c *********************************/ 
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	17 Jan 93 

 This file encapsulates everything that an application might want
 to do with the LAP Manager.  It provides glue routines to all the
 LAP Manager calls.

*/

#include <stddef.h>
#include <AppleTalk.h>
#include <OSUtils.h>
#include "LAPMgrGlue.h"

/*******************
 * L M W R T G E T *
 *******************

 LMWrtGet returns the currently selected atlk connection.
 
*/

ProcPtr * LMWrtGet(short thePort)
{

}

/*************************
 * L M W R T I N S E R T *
 *************************

 LMWrtInsert installs a new Atlk connection on the specified port.  The 
 LAPManager uses the flags as described on p. 33 of the MACPG. 
 The LAP Manager also tries to get an unused node adrs maxTries times
 
*/

short LMWrtInsert(void *atlkRsrc, short flags, short maxTries, short thePort)
{
	return (noErr);
}

/*************************
 * L M W R T R E M O V E *
 *************************

 LMWrtRemove removes the AppleTalk connection for the specified port.
 
*/

short LMWrtRemove(short thePort)
{
	return(noErr);
}

/***************************
 * L M R D D I S P A T C H *
 ***************************

 LMRdDispatch is called by the atlk whenever a frame has arrived from the link. 
 This call passes the frame up to the .MPP protocol stack. On exit, the packet, 
 and any error conditions, have been handled by the LAP Mgr and LMRdDispatch.
 
 On entry, the regs array must hold the following values:
     offset 	0  (rD1)	remaining packet length
     		1  (rD2)	LAPType + addrRefNum (in high word)
     		2  (rD3)	ptr to link source adrs (extended)
     		3  (rA0)	avail to atlk - preserved until ReadRest call
     		4  (rA1)	avail to atlk - preserved until ReadRest call
     		5  (rA2)	ptr to .MPP variables
     		6  (rA3)	ptr past 5 hdr bytes in .MPP toRHA (non-ext)
     		7  (rA4)	ptr to ReadPacket routine
     		8  (rA5)	avail for .MPP; restored after ReadRest called
     		
 LMRdDispatch pushes two return addresses (a "good" and "error" entry point) 
 onto the stack. Then it loads the values above into the proper registers. 
 Finally, LMRdDispatch calls the LAP Manager. 

 The LAPMgr will attempt to pass the packet off to a protocol handler. If it is 
 successful, it'll first pop off the first "error" address" (@1 in this code) 
 transfer to the protocol handler, and wind up returning to @2. If no protocol 
 handler is there, the LAP Mgr will return to @1, which must pop off @2. In 
 either case, the stack is now prepared to return to the original caller of 
 LMRdDispatch.
 
*/

void	LMRdDispatch (char * theData, short theLen,  
			short theAddrRef, Ptr linkAdrs, Ptr MPPVars)
{ 

}
			
/*********************
 * L S E T I N U S E *
 *********************

 LSetInUse informs the LAP Manager that the address it suggested (in the LAPEnq
 call) is already in use. 
 
*/

short	LMSetInUse (Ptr MPPVars)
{
	return (noErr);
}


short	LMGetSelfSend (Ptr MPPVars) 
		{ DebugStr("\pLMGetSelfSend"); return (noErr); }
short	LMAARPAttach (long protocolType, short drvrRefNum, ProcPtr theListener)
		{ DebugStr("\pLMAARPAttach"); return (noErr); }
short	LMAARPDetach (long protocolType, short drvrRefNum)
		{ DebugStr("\pLMAARPDetach"); return (noErr); }
long	LMGetATalkInfo (void)
		{ DebugStr("\pLMGetATalkInfo"); return (noErr); }
long	LMGetPortInfo (short thePort)
		{ DebugStr("\pLMGetPortInfo"); return (noErr); }
short	LMOpenADEV (short adevFileID, short* index, char* filename, short* fileRefnum)
		{ DebugStr("\pLMOpenADEV"); return (noErr); }

/***********************
 * L N S E T I N U S E *
 ***********************

 LNSetInUse informs the LAP Manager that the address it suggested (in the LAPEnq
 call) is already in use. 
 
*/

short	LMNSetInUse (Ptr MPPVars, short thePort)
{
	return(noErr);
}


short	LM802Attach (ProcPtr handler, Ptr protSpecification, short ENETrefNum)
		{ DebugStr("\pLM802Attach"); return (noErr); }
		
short	LM802Detach (Ptr protSpecification, short ENETrefNum)
		{ DebugStr("\pLM802Detach"); return (noErr); }

/*******************
 * L M G E T A E Q *
 *******************

 LMGetAEQ - Get pointer to AppleTalk Event Queue
 
*/
 
QHdr *LMGetAEQ(void)
{
	DebugStr("\pLMGetAEQ");
	return (NULL);
}
