/******************************* LAPMgrGlue.h *********************************/ 
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	17 Jan 93 

*/

#define _H_LAPMgrGlue
 
#define LRdDispatch	1
#define LWrtInsert	2
#define LWrtRemove	3
#define LWrtGet		4
#define LSetInUse	5
#define LGetSelfSend	6
#define LAARPAttach	7
#define LAARPDetach	8
#define LGetATalkInfo	9
#define LGetPortInfo	10
#define LOpenADEV	11
#define LNSetInUse	12
#define L802Attach	21
#define L802Detach	22
#define LGetAEQ		25

enum 		{	
//	ATTransOpen = 0, 
//	ATTransClose = 2, 
//	ATTransClosePrep = 3, 
//	ATTransCancelClose = 4,
	ATTransNetworkTransition = 5,
	ATTransNameChangeTellTask = 6,
	ATTransNameChangeAskTask = 7,
	ATTransCancelNameChange = 8
};

#define ATTransCableChange = 'rnge'
#define ATTransSpeedChange = 'sped'

typedef struct TNetworkTransition	{
	long	private;		// used by ARA/ADEV
	ProcPtr	netValidProc;		// network validation procedure
	Boolean newConnectivity;	// true if new conn; false if lost conn
} TNetworkTransition;

typedef struct TNewCRTrans		{
	short	newCableLo;		// new cable lo received from RTMP
	short	newCableHi;		// new cable hi received from RTMP
};
// These routines have "LM" replacing the "L" in the "official" names to 
// 	avoid conflict with AppleTalk.h

void	LMRdDispatch (char * theData, short theLen,  
			short theAddrRef, Ptr linkAdrs, Ptr MPPVars);
short	LMWrtInsert (void *atlkRsrc, short flags, short maxTries,short thePort);
short	LMWrtRemove (short thePort);
ProcPtr	*LMWrtGet(short thePort);
short	LMSetInUse(Ptr MPPVars);
short	LMGetSelfSend (Ptr MPPVars);
short	LMAARPAttach (long protocolType, short drvrRefNum, ProcPtr theListener);
short	LMAARPDetach (long protocolType, short drvrRefNum);
long	LMGetATalkInfo (void);
long	LMGetPortInfo (short thePort);
short	LMOpenADEV (	short adevFileID, short* index, char* filename, 
			short* fileRefnum);
short	LMNSetInUse(Ptr MPPVars, short thePort);
short	LM802Attach(ProcPtr handler, Ptr protSpecification, short ENETrefNum);
short	LM802Detach(Ptr protSpecification, short ENETrefNum);
//	LMAddAEQ - Use LAPAddATQ from the AppleTalk.h
//	LMRmvAEQ - Use LAPRmvATQ from AppleTalk.h
QHdr	*LMGetAEQ(void);

long	ReadPacketCode(void);			// the ReadPacket/ReadRest code
