/****************************** MTadev.c **************************************/ 
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	22 March 1993

 This file implements the AppleTalk-connection-specific features of the adev.
 
 For ModemTalk, the user interface is implemented entirely by the atlk resource.
 Selecting the ADEV the first time (on a SelADEV call) simply returns the 
 suggested PRAM value. The Network control panel will subsequently send an 
 AInstall message to the atlk resource, and the atlk will display the user
 interface.
 
 Selecting the ADEV when it's already selected (ReselADEV call) will cause the
 adev code to make a back door call to the atlk resource's command entry point, 
 requesting that it display the user interface and "run itself" again.
 
*/ 

#include <AppleTalk.h>
#include "adev.h"
#include "MTadev.h"
#include "LAPMgrGlue.h"

OSErr LinkSelADEV(adevRegs* regs)
{
	return (noErr);
}

OSErr LinkReselADEV(adevRegs* regs)
{
	ProcPtr	atlkAdrs;
	short	theResult;
	Cursor	wCursor;
	CursHandle cursH;

	cursH = GetCursor(watchCursor);		// display the watch
	HLock((Handle) cursH);			// 'til the MT DLOG comes up
	wCursor = **cursH;
	SetCursor(&wCursor);
	
	asm	{				// call it with the proper
		moveq	#LWrtGet,D0		// LWrtGet parameter
		move.l	D4,-(SP)
		moveq	#0,D4			// DEBUG! Ask about port zero
		movea.l	LAPMgrPtr,A0
		jsr	2(A0)
		move.l	(SP)+,D4		// restore D4
		tst.w	D0
		bne.s	@1
		
// A0 now contains the atlk's address

		move.l	#kDisplayUI,D0		// Display UI command code
		jsr	2(A0)			// call the atlk code
@1:
		move.w	D0,theResult
	}
	
	return (theResult);
}