/*************************** ModemTalk.h **************************************/ 
#define _H_ModemTalk
/*
	Copyright  1993, Trustees of Dartmouth College
	
	Richard E. Brown
	
	Release date:	17 Jan 93 

 This file contains #defines and global variables for the ModemTalk connection. 
 
*/

#include 	"TrapPatches.h"

/*********************
 * P A T C H T R A P *
 *********************
 
 PatchTrap patches the Open and Close traps for the serial drivers, to
 prevent other applications from confusing ModemTalk.
   
*/

/*********************
 * P A T C H T R A P *
 *********************
 
 PatchTrap installs a patch for a trap. It returns a pointer to the patched
 routine... 
 
*/

ProcPtr	PatchTrap(short theTrap, short refNum1, short refNum2)
{
	Ptr	thePatchBlock;
	
	asm		{
@thePatch:	
		move.w	0x18(A0),D0		// get the refnum from PB
		cmp.w	@refn1,D0		// compare to one refNum
		beq.s	@1			// go if we have a match
		cmp.w	@refn2,D0
		beq.s	@1
		
		move.l	@realAdrs,-(SP)		// not one of our refnum's
		rts				// just go to it
		
@1:		move.w	@failStatus,D0		// otherwise, return bad status
		rts
		
@realAdrs:	dc.l	1			// address of the real trap
@patchedTrap:	dc.w	1			// trap word that was patched
@refn1:		dc.w	1			// first refNum 
@refn2:		dc.w	1			// second refNum
@failStatus:	dc.w	1			// (bad)status to return
@patchCode:
@patchEnd:
	}
}

void	UnPatchTrap(void *thePatch)
{

}

/* Facilities That Are Provided for You

Apple provides some system calls that let you flush the data and 
instruction caches without using privileged instructions (which is, 
as you should all know by now, a major no-no).

Following are the interfaces for these calls, for MPW Pascal and C 
(respectively):

FUNCTION SwapInstructionCache (cacheEnable: BOOLEAN) : BOOLEAN;
pascal Boolean SwapInstructionCache (Boolean cacheEnable);

This call enables or disables the instruction cache according to 
the state passed in cacheEnable and returns the previous state of the 
instruction cache as a result.

PROCEDURE FlushInstructionCache;
pascal void FlushInstructionCache (void);

This call flushes the current contents of the instruction cache. This has 
an adverse effect on CPU performance, so only call it when absolutely 
necessary.

FUNCTION SwapDataCache (cacheEnable: BOOLEAN) : BOOLEAN;
pascal Boolean SwapDataCache (Boolean cacheEnable);

This call enables or disables the data cache according to the state 
passed in cacheEnable and returns the previous state of the data cache 
as a result.

PROCEDURE FlushDataCache;
pascal void FlushDataCache (void);

This call flushes the current contents of the data cache. This has an 
adverse effect on CPU performance, so only call it when absolutely 
necessary.

Note:    Before you call any of these routines, make sure that the 
_HwPriv ($A198) trap is implemented, or your program will crash. _HwPriv 
is implemented in the Macintosh IIx ROMs and later, as well as 
System 6.0.3 and later. The correct way to check for the trap is using 
the TrapAvailable function documented in Inside Macintosh Volume VI 
(pages 3-7 to 3-9).
*/
