/*********
 * L O G *
 *********
 
 Keep a history log an 8-char string, and two longs anytime it's interesting

*/


#include <stdio.h>
#include "histlog.h"
#include "mySetupA4.h"
#include "atlk.h"

long		debugBuf[4*64];		// DEBUG! 64 samples, each containing four long's
long		*debugPtr=0;		// DEBUG! next location in buf
long		*nextPtr;

void histlog (char * str, long val1, long val2)
{
	register long	*sp;
	register long	*dp;
	
#ifndef TESTAPPL
	SetUpA4();
#endif

	if (!debugPtr) 	{			// Initialize debugPtr
		debugPtr = (long*)&debugBuf;	
		*debugPtr = 0x3F3F3F3F;		// init to question marks
	}
	
	dp = debugPtr;
	sp = (long*) str;
	
	*dp++ = *sp++;
	*dp++ = *sp++;				// copy the 8 chars
	*dp++ = val1;
	*dp++ = val2;				// save the two longs
	
	if (((char*)dp - (char*)&debugBuf[0]) >= sizeof(debugBuf))
		dp = (long*) &debugBuf;
	debugPtr = dp;				// save pointer for next time
	*dp = 0x20202020;			// and mark next place w/ spaces
	
#ifndef TESTAPPL
	RestoreA4();
#endif
}

void	ShowHistBuf(void)
{		
		asm {lea debugBuf,a0};
		DDebugStr("\pDebugBuf;dm a0;g"); // leave a hint of buffer's adrs
}

// return the first line from the log. Line is ASCII; %s:8, %Lx, %Lx \r\0

Boolean	GetFirstLine(char *theLog)
{
	nextPtr = debugPtr;					// point at first one
	return(GetNextLine(theLog));
}

// return the next line from the log; returns TRUE if it's the last

Boolean GetNextLine(char *theLog)
{
	register long	*l1, *l2;
	
	l1 = nextPtr;
	l1++;
	l1++;
	l2 = l1;
	l2++;
	sprintf(theLog, "%8.8s %lX %8lX",*nextPtr, *l1, *l2);
	nextPtr = l2++;
	if (((char*)nextPtr - (char*)&debugBuf[0]) >= sizeof(debugBuf))
		nextPtr = (long*) &debugBuf;

	return(nextPtr == debugPtr);
}