/*****************************************************************************
 *
 *	FILE:	Help.c
 *	CREA:	Rich Brown
 *	MODF:	Friday, November 2, 1990 @ 10:10:29 PM
 *	HIST:	11/2/90 (1.0)	Recoded from LSP by reb.
 *							Original code from R. Fronabarger
 *
 *****************************************************************************/

#include "Help.h"
#include "SetupA4.h"			

#define CODERSRC 1		/* comment this out if building an application */

typedef	struct 
	{
		short textRsrc;
		short stylRsrc;
	} TopicSet;
	
typedef struct
	{	
		short 		numTopics;
		TopicSet	topicSets[1];
	} HelpList,*helpListPtr, **HelpListHdl;

#pragma mark _Variables

	DialogPtr		myDialog;
	HelpListHdl		myHelpListH;
	ListHandle		theList;
	short			pagesize, numTopics;
	Handle			textRes, numTopicsH;
	ControlHandle	sBar;
	TEHandle		theText;

#pragma mark _Prototypes

void 	CreateIndexList(short strNumID);
pascal void ScrAction (ControlHandle theCtl, short partCode);
void 	WindowScroll (Point thePt, WindowPtr theWindow);
void 	LoadText (short item);
pascal  Boolean MyFilter (DialogPtr theDialog, EventRecord *theEvent, short *itemHit);
 

void CreateIndexList(short strNumID)
{
short		i, iType;
char 		topicStr[256];
Rect		iRect, dataBounds;
Cell		cSize, theCell;
Handle		iHandle;
FontInfo	fontInfo;

	GetDItem(myDialog, 3, &iType, &iHandle, &iRect);
	FrameRect(&iRect);
	InsetRect(&iRect, 1, 1);
	SetRect(&dataBounds, 0, 0, 1, numTopics);
	GetFontInfo(&fontInfo);	
	cSize.v = fontInfo.ascent + fontInfo.descent + fontInfo.leading + 1;
	cSize.h = iRect.right - iRect.left;
	theList = LNew(&iRect, &dataBounds, cSize, 0, myDialog, FALSE, FALSE, FALSE, TRUE);
													/* drawIt, hasGrow, hScroll, vScroll */
	for (i = 1; i <= numTopics; i++)		
	{
		GetIndString((StringPtr) &topicStr, strNumID, i);
		SetPt(&theCell, 0, i - 1);
		LSetCell(&topicStr[1], topicStr[0], theCell, theList);
	}
	(**theList).selFlags = lOnlyOne;
	SetPt(&theCell, 0, 0);
	LSetSelect(TRUE, theCell, theList);
	LDoDraw(TRUE, theList); 
}

pascal void ScrAction (ControlHandle theCtl, short partCode)
{
short delta, oldValue;

	switch (partCode)
	{
		case inUpButton: 
			delta = -10; break;
		case inDownButton: 
			delta = 10; break;
		case inPageUp: 
			delta = -pagesize; break;
		case inPageDown: 
			delta = pagesize; break;
	}
	if (partCode != 0)
	{ 
		oldValue = GetCtlValue(theCtl);
		SetCtlValue(theCtl, oldValue + delta);
		TEScroll(0, oldValue - GetCtlValue(theCtl), theText);
	}
}
/*****************************************************************************
 WindowScroll - scroll the info window's contents
 *****************************************************************************/


void WindowScroll (Point thePt, WindowPtr theWindow)
{
	ControlHandle	theCtl;
	short			part, oldValue;
	
	GlobalToLocal(&thePt);
	switch (FindControl(thePt, theWindow, &theCtl)) 
	{
		case inThumb: 
			oldValue = (**theText).viewRect.top - (**theText).destRect.top;
			if (TrackControl(theCtl, thePt, nil) != 0)
				TEScroll(0, oldValue - GetCtlValue(theCtl), theText);
			break;
		default:
			part = TrackControl((ControlHandle) theCtl, thePt, (ProcPtr) &ScrAction);
			break;
	}
}

void LoadText (short item)
{
	#define inactive  255

	short	max, textNum, stylNum;
	Handle	textRes, stylRes;

	TEDeactivate(theText);
	TESetSelect(0, 32767, theText);
	TEDelete(theText);
	(**theText).destRect = (**theText).viewRect;
	textNum = (**myHelpListH).topicSets[item].textRsrc;
	stylNum = (**myHelpListH).topicSets[item].stylRsrc;
	if ((textNum != 0) && (stylNum != 0))
	{
		textRes = GetResource('TEXT', textNum);
/*		if (textRes == nil) */
/*			*//*DebugStr("\pno TEXT rsrc")*//*;*/
		stylRes = GetResource('styl', stylNum);
/*		if (stylRes == nil)*/
/*			*//*DebugStr("\pno styl rsrc")*//*;*/
		HLock(textRes);
		HLock(stylRes);
		TEStylInsert(*textRes, SizeResource(textRes), (StScrpHandle)stylRes, theText);
		HUnlock(stylRes);
		HUnlock(textRes);
	}
	max = TEGetHeight((**theText).nLines, 0, theText) - pagesize;
	if (max > 0)
		HiliteControl(sBar, activeFlag);
	else
		HiliteControl(sBar, inactive);
	SetCtlValue(sBar, 0);
	SetCtlMax(sBar, max);
	TEActivate(theText);
}

pascal Boolean MyFilter (DialogPtr theDialog, EventRecord *theEvent, short *itemHit)
{
	short		iType, part;
	Rect		iBox;
	Handle		iHdl;
	Point		thePt;
	ControlHandle	theCtl;
	Boolean		ignore;
	Cell		newCell;
	char		theChar;
	Boolean		retval;
	long		l;

#ifdef CODERSRC
//	SetUpA4();				// got globals again (in A4)
#endif	
	retval = FALSE;
	theChar = (char) BitAnd(theEvent->message, charCodeMask);
	switch (theEvent->what)
	{
	case keyDown: case autoKey:  
		if ((theChar == 3) || (theChar == 13))
		{
			retval = TRUE;
			*itemHit = 1;
		}
		break;
	case mouseDown: 
		thePt = theEvent->where;
		GlobalToLocal(&thePt);
		part = FindControl(thePt, myDialog, &theCtl);
		if (theCtl == sBar)
			WindowScroll(theEvent->where, myDialog);
		else if (theCtl == (**theList).vScroll)
			ignore = LClick(thePt, theEvent->modifiers, theList);
		else if (PtInRect(thePt, &(**theList).rView))
		{
			ignore = LClick(thePt, theEvent->modifiers, theList);
			SetPt(&newCell, 0, 0);
			ignore = LGetSelect(TRUE, &newCell, theList);
			LoadText(newCell.v);
		}
		break;
	case updateEvt: 
		BeginUpdate(myDialog);
		TEUpdate(&(**theText).viewRect, theText);
		LUpdate((*myDialog).visRgn, theList);
		EndUpdate(myDialog);
		break;
	}
	if (retval)
	{
		GetDItem(theDialog, *itemHit, &iType, &iHdl, &iBox);
		HiliteControl((ControlHandle) iHdl, inButton);
		Delay(10, &l);
		HiliteControl((ControlHandle) iHdl, 0);
	}

#ifdef CODERSRC
//	RestoreA4();				// back to the real world
#endif

	return(retval);
}

void Help (short rsrcNum, short indexFontNum, short indexFontSize)
{
	GrafPtr		savePort;
	Rect		iBox, tBox;
	short		iType, itemHit;
	Handle		iHdl;
	short		**shortHdl;

	GetPort(&savePort);
	myDialog = GetNewDialog(rsrcNum, (DialogPeek) nil, (WindowPtr)-1);
/*	if (myDialog == nil) */
/*		DebugStr("\pno help dialog");*/
	SetPort(myDialog);
	ShowWindow(myDialog);
	TextFont(indexFontNum);
	TextSize(indexFontSize);
	shortHdl = (short**) GetResource('STR#', rsrcNum);
	numTopics = **shortHdl;
	myHelpListH = (HelpListHdl) GetResource('HLP#', rsrcNum);
/*	if (myHelpListH == nil) */
/*		DebugStr("\pno HLP# rsrc");*/
	HLock((Handle) myHelpListH);
	CreateIndexList(rsrcNum);
	GetDItem(myDialog, 2, &iType, &iHdl, &tBox);
	FrameRect(&tBox);
	InsetRect(&tBox, 4, 2);
	pagesize = tBox.bottom - tBox.top;
	theText = TEStylNew(&tBox, &tBox);
	HLock((Handle) theText);
	GetDItem(myDialog, 6, &iType, &iHdl, &iBox);
	sBar = (ControlHandle)iHdl;
	GetDItem(myDialog, 1, &iType, &iHdl, &iBox);
	InsetRect(&iBox, -4, -4);
	PenSize(3, 3);
	FrameRoundRect(&iBox, 16, 16);
	PenSize(1, 1);
	LoadText(0);
	for (;;)
	{
		ModalDialog((ModalFilterProcPtr) &MyFilter, &itemHit);
		if (itemHit == 1) break;
	}
	HUnlock((Handle) theText);
	LDispose(theList);
	DisposDialog(myDialog);
	SetPort(savePort);
}