/*****************************
 * T R A P A V A I L A B L E *
 *****************************
 
 TrapAvailable returns true if the trap passed in is implemented
 in this machine. Transliterated directly from the IM-VI stack.
 
  6 April 1993  reb
 27 April 1993  reb Fixed transliteration from the stack...
 
*/

#include 	"TrapAvailable.h"

short		NumToolboxTraps(void);
TrapType	GetTrapType(short theTrap);

#include <Traps.h>
#define TrapMask 0x0800

short	NumToolboxTraps(void)
{
	if (NGetTrapAddress(_InitGraf, ToolTrap) 
	  			== NGetTrapAddress(0xAA6E, ToolTrap))
			return(0x0200);
	else 	return (0x0400);
}

TrapType	GetTrapType(short theTrap)
{

	if (theTrap & TrapMask)
			return(ToolTrap);
	else 	return(OSTrap);
}

Boolean	TrapAvailable (short theTrap)
{
	TrapType	tType;
	short		localTrap;			/* local copy of the trap instruction */
	
	localTrap = theTrap;
	tType = GetTrapType(localTrap);
	if (tType == ToolTrap)	{
		localTrap &= 0x07FF;
		if (localTrap >= NumToolboxTraps())
			localTrap = _Unimplemented;
	}
	return(NGetTrapAddress(localTrap, tType) 
			!= NGetTrapAddress(_Unimplemented, ToolTrap));
}