// File "sysmenu.h" - 

#ifndef ____SYSMENU_HEADER____
#define ____SYSMENU_HEADER____

// * ******************************************************************************* *
// * ******************************************************************************* *

// Basic debugging flag that enables/disables all Debug() 
// and DebugStr() calls embedded into the source files.
// #define ____DEBUG____ 

// When we install the Menu, we will try to get this MenuID. If 
// there is already one (2 copies of INIT?), we will do our best
// to get another (but close) ID. (See InsertMenu patch)
#define kPrefMenuID		-19999

// This is an icon family for the menu. Currently the value is set
// to something guaranteed to be available (from the system file).
// You can set it to an icon from your resfile or to 0 for no icon.
#define kPrefIconID		-16396

// * ******************************************************************************* *
// * ******************************************************************************* *

typedef struct {
	ProcPtr saveInsertMenu;
	ProcPtr saveDrawMenuBar;
	ProcPtr saveMenuSelect;
	ProcPtr saveSystemMenu;
	
	short menuID, **sysMenus;
	MenuHandle mHdl;
	Handle menuIcon;
	FSSpec homeFile;
	} GlobalsRec;

// * ******************************************************************************* *
// * ******************************************************************************* *
// Function Prototypes

void __Startup__(void);
void main(void);
short CurResFileAsFSSpec(FSSpec *fileSpec);
ProcPtr ApplyTrapPatch(short trap, ProcPtr patchPtr);
pascal short DetachIcons(long iconType, Handle *iconHdl, void *data);

pascal void Patched_InsertMenu(MenuHandle menu, short beforeID);
pascal void Patched_DrawMenuBar(void);
pascal long Patched_MenuSelect(Point where);
pascal void Patched_SystemMenu(long result);

#endif  ____SYSMENU_HEADER____
